import requestHandler from '../util/requestHandler';
import querystring from 'querystring';

export default {
  getCustomLine: async (param) => {
    const url = `/fms-rest/rest/customLine?_method=get`;
    return await requestHandler({
      url,
      option: {
        method: "POST",
        body: querystring.stringify(param),
        needLoad: true
      }
    });
  },
  saveCustomLine: async (param) => {
    const url = `/fms-rest/rest/customLine`;
    return await requestHandler({
      url,
      option: {
        method: "POST",
        body: querystring.stringify(param),
        needLoad: true
      }
    });
  },
  saveCustomPageSize: async (customVo, pageSize) => {
    const url = `/fms-rest/rest/customLine/savePageSize`;
    return await requestHandler({
      url,
      option: {
        method: "POST",
        body: querystring.stringify({
          pageSize,
          ...customVo,
        }),
        needLoad: true
      }
    });
  }
}