import _ from 'lodash';
import $ from 'jquery';

export default {
  setDraggableColumns: (currentTable) => {
    let columns = currentTable.getUserDefinedColumns(currentTable.getCustomColumns());

    let { scroll } = currentTable.props;
    let {
      timeId
    } = currentTable.state;
    let haveColumnFixed = false;
    for (let i of columns) {
      if (i.fixed) {
        haveColumnFixed = true;
        break;
      }
    }
    $('#' + timeId + ' th,td').css({
      position: 'relative'
    });
    for (let k = 0; k < $('#' + timeId + ' table').length; k++) {
      for (
        let i = 0; i <
        $('#' + timeId + ' table')
        .eq(k)
        .find('th').length; i++
      ) {
        if ($('#' + timeId + ' table').eq(k).find('th').eq(i).find('.druagle-border').length !== 0) {
          continue;
        }
        $('#' + timeId + ' table')
          .eq(k)
          .find('th')
          .eq(i)
          .append(
            '<div dataIndex=' +
            i +
            ' tableIndex=' +
            k +
            ' class="druagle-border" style="width:0;height:100%;border-right:2px solid transparent;cursor:e-resize;position:absolute;right:0;top:0"></div>'
          );
      }
    }
    let isMoveStart = false;
    let oldX = 0;
    let oldWidth = 0;
    let oldTableWidth = 0;
    let selectIndex = 0;
    let tableIndex = 0;
    let tableThis;
    $('#' + timeId + ' th .druagle-border').on('mousedown', function () {
      isMoveStart = true;
      oldX = event.screenX;
      oldWidth = $('#' + timeId + ' table')
        .eq($(this).attr('tableIndex'))
        .find('th')
        .eq($(this).attr('dataIndex'))
        .width();
      selectIndex = $(this).attr('dataIndex');
      tableIndex = $(this).attr('tableIndex');
      oldTableWidth = $('#' + timeId + ' table')
        .eq($(this).attr('tableIndex'))
        .width();
      tableThis = $('#' + timeId + ' table').eq($(this).attr('tableIndex'));
      $('#' + timeId + ' col').css({
        minWidth: 50
      });
    });

    $('#' + timeId + ' table').on('mousemove', function () {
      if (isMoveStart && event.screenX - oldX + oldWidth > 50) {
        $('#' + timeId + ' .ant-table-fixed-left th').height(tableThis.find('th').height());
        $('#' + timeId + ' .ant-table-fixed-right th').height(tableThis.find('th').height());
        for (let i = 0; i < tableThis.find('tr').length; i++) {
          $('#' + timeId + ' .ant-table-fixed-left tr')
            .eq(i)
            .height(
              tableThis
              .find('tr')
              .eq(i)
              .height()
            );
          $('#' + timeId + ' .ant-table-fixed-right tr')
            .eq(i)
            .height(
              tableThis
              .find('tr')
              .eq(i)
              .height()
            );
        }
        if (scroll && scroll.y && !haveColumnFixed) {
          for (let i = 0; i < $('#' + timeId + ' table').length; i++) {
            $('#' + timeId + ' table')
              .eq(i)
              .find('col')
              .eq(selectIndex)
              .width(event.screenX - oldX + oldWidth);
            $('#' + timeId + ' table')
              .eq(i)
              .width(oldTableWidth + event.screenX - oldX + oldWidth - oldWidth);
          }
        } else if (scroll && scroll.y && haveColumnFixed) {
          //暂设置为 fixed部分table不允许拖动。
          if (
            tableThis
            .parent()
            .parent()
            .attr('class') == 'ant-table-scroll'
          ) {
            for (
              let i = 0; i <
              tableThis
              .parent()
              .parent()
              .find('table').length; i++
            ) {
              tableThis
                .parent()
                .parent()
                .find('table')
                .eq(i)
                .find('col')
                .eq(selectIndex)
                .width(event.screenX - oldX + oldWidth);
              tableThis
                .parent()
                .parent()
                .find('table')
                .eq(i)
                .width(oldTableWidth + event.screenX - oldX + oldWidth - oldWidth);
            }
          }
        } else {
          if (
            tableThis
            .parent()
            .parent()
            .attr('class') == 'ant-table-scroll'
          ) {
            $('#' + timeId + ' table')
              .eq(tableIndex)
              .find('col')
              .eq(selectIndex)
              .width(event.screenX - oldX + oldWidth);
            $('#' + timeId + ' table')
              .eq(tableIndex)
              .width(oldTableWidth + event.screenX - oldX + oldWidth - oldWidth);
          }
        }
      }
    });
    $('#' + timeId + ' table').on('mouseup', function () {
      isMoveStart = false;
    });
    $('#' + timeId + ' table').on('mouseleave', function () {
      isMoveStart = false;
    });
  }
}