'use strict';

var _throttleByAnimationFrame = require('../throttleByAnimationFrame');

var _throttleByAnimationFrame2 = _interopRequireDefault(_throttleByAnimationFrame);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

jest.useFakeTimers();

describe('Test utils function', function () {
  it('throttle function should work', function () {
    var callback = jest.fn();
    var throttled = (0, _throttleByAnimationFrame2.default)(callback);
    expect(callback).not.toBeCalled();

    throttled();
    throttled();

    jest.runAllTimers();
    expect(callback).toBeCalled();
    expect(callback.mock.calls.length).toBe(1);
  });

  it('throttle function should be canceled', function () {
    var callback = jest.fn();
    var throttled = (0, _throttleByAnimationFrame2.default)(callback);

    throttled();
    throttled.cancel();

    jest.runAllTimers();
    expect(callback).not.toBeCalled();
  });
});