'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('AutoComplete with Custom Input Element Render', function () {
  it('AutoComplete with custom Input render perfectly', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { dataSource: ['12345', '23456', '34567'] },
      _react2.default.createElement('textarea', null)
    ));

    expect(wrapper.find('textarea').length).toBe(1);
    wrapper.find('textarea').simulate('change', { target: { value: '123' } });
    var dropdownWrapper = (0, _enzyme.mount)(wrapper.find('Trigger').node.getComponent());

    // should not filter data source defaultly
    expect(dropdownWrapper.find('MenuItem').length).toBe(3);
  });

  it('child.ref should work', function () {
    var mockRef = jest.fn();
    (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { dataSource: [] },
      _react2.default.createElement('input', { ref: mockRef })
    ));
    expect(mockRef).toHaveBeenCalled();
  });
});