'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Breadcrumb', function () {
  var errorSpy = jest.spyOn(console, 'error').mockImplementation(function () {});

  afterEach(function () {
    errorSpy.mockReset();
  });

  afterAll(function () {
    errorSpy.mockRestore();
  });

  // https://github.com/airbnb/enzyme/issues/875
  it('warns on non-Breadcrumb.Item children', function () {
    var MyCom = function MyCom() {
      return _react2.default.createElement(
        'div',
        null,
        'foo'
      );
    };
    (0, _enzyme.mount)(_react2.default.createElement(
      _index2.default,
      null,
      _react2.default.createElement(MyCom, null)
    ));
    expect(errorSpy.mock.calls).toHaveLength(1);
    expect(errorSpy.mock.calls[0][0]).toMatch('Breadcrumb only accepts Breadcrumb.Item as it\'s children');
  });

  // https://github.com/ant-design/ant-design/issues/5015
  it('should allow Breadcrumb.Item is null or undefined', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(
      _index2.default,
      null,
      null,
      _react2.default.createElement(
        _index2.default.Item,
        null,
        'Home'
      ),
      undefined
    ));
    expect(errorSpy).not.toHaveBeenCalled();
    expect(wrapper).toMatchSnapshot();
  });

  // https://github.com/ant-design/ant-design/issues/5542
  it('should not display Breadcrumb Item when its children is falsy', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(
      _index2.default,
      null,
      _react2.default.createElement(_index2.default.Item, null),
      _react2.default.createElement(
        _index2.default.Item,
        null,
        'xxx'
      ),
      _react2.default.createElement(
        _index2.default.Item,
        null,
        'yyy'
      )
    ));
    expect(wrapper).toMatchSnapshot();
  });
});