'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

var _icon = require('../../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Button', function () {
  it('renders correctly', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(
      _2.default,
      null,
      'Follow'
    ));
    expect(wrapper).toMatchSnapshot();
  });

  it('renders Chinese characters correctly', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(
      _2.default,
      null,
      '\u6309\u94AE'
    ));
    expect(wrapper).toMatchSnapshot();
    // should not insert space when there is icon
    var wrapper1 = (0, _enzyme.render)(_react2.default.createElement(
      _2.default,
      { icon: 'search' },
      '\u6309\u94AE'
    ));
    expect(wrapper1).toMatchSnapshot();
    // should not insert space when there is icon
    var wrapper2 = (0, _enzyme.render)(_react2.default.createElement(
      _2.default,
      null,
      _react2.default.createElement(_icon2.default, { type: 'search' }),
      '\u6309\u94AE'
    ));
    expect(wrapper2).toMatchSnapshot();
  });

  it('have static perperty for type detecting', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      null,
      'Button Text'
    ));
    // eslint-disable-next-line
    expect(wrapper.type().__ANT_BUTTON).toBe(true);
  });

  it('should change loading state instantly by default', function () {
    var DefaultButton = function (_Component) {
      (0, _inherits3.default)(DefaultButton, _Component);

      function DefaultButton() {
        var _ref;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, DefaultButton);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DefaultButton.__proto__ || (0, _getPrototypeOf2.default)(DefaultButton)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
          loading: false
        }, _this.enterLoading = function () {
          _this.setState({ loading: true });
        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
      }

      (0, _createClass3.default)(DefaultButton, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            _2.default,
            { loading: this.state.loading, onClick: this.enterLoading },
            'Button'
          );
        }
      }]);
      return DefaultButton;
    }(_react.Component);

    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(DefaultButton, null));
    wrapper.simulate('click');
    expect(wrapper.hasClass('ant-btn-loading')).toBe(true);
  });

  it('should change loading state with delay', function () {
    // eslint-disable-next-line
    var DefaultButton = function (_Component2) {
      (0, _inherits3.default)(DefaultButton, _Component2);

      function DefaultButton() {
        var _ref2;

        var _temp2, _this2, _ret2;

        (0, _classCallCheck3.default)(this, DefaultButton);

        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        return _ret2 = (_temp2 = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref2 = DefaultButton.__proto__ || (0, _getPrototypeOf2.default)(DefaultButton)).call.apply(_ref2, [this].concat(args))), _this2), _this2.state = {
          loading: false
        }, _this2.enterLoading = function () {
          _this2.setState({ loading: { delay: 1000 } });
        }, _temp2), (0, _possibleConstructorReturn3.default)(_this2, _ret2);
      }

      (0, _createClass3.default)(DefaultButton, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            _2.default,
            { loading: this.state.loading, onClick: this.enterLoading },
            'Button'
          );
        }
      }]);
      return DefaultButton;
    }(_react.Component);

    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(DefaultButton, null));
    wrapper.simulate('click');
    expect(wrapper.hasClass('ant-btn-loading')).toBe(false);
  });
});