'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('CheckboxGroup', function () {
  it('should work basically', function () {
    var onChange = jest.fn();
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_index2.default.Group, { options: ['Apple', 'Pear', 'Orange'], onChange: onChange }));
    wrapper.find('.ant-checkbox-input').at(0).simulate('change');
    expect(onChange).toBeCalledWith(['Apple']);
    wrapper.find('.ant-checkbox-input').at(1).simulate('change');
    expect(onChange).toBeCalledWith(['Apple', 'Pear']);
    wrapper.find('.ant-checkbox-input').at(2).simulate('change');
    expect(onChange).toBeCalledWith(['Apple', 'Pear', 'Orange']);
    wrapper.find('.ant-checkbox-input').at(1).simulate('change');
    expect(onChange).toBeCalledWith(['Apple', 'Orange']);
  });

  it('does not trigger onChange callback of both Checkbox and CheckboxGroup when CheckboxGroup is disabled', function () {
    var onChangeGroup = jest.fn();

    var options = [{ label: 'Apple', value: 'Apple' }, { label: 'Pear', value: 'Pear' }];

    var groupWrapper = (0, _enzyme.mount)(_react2.default.createElement(_index2.default.Group, { options: options, onChange: onChangeGroup, disabled: true }));
    groupWrapper.find('.ant-checkbox-input').at(0).simulate('change');
    expect(onChangeGroup).not.toBeCalled();
    groupWrapper.find('.ant-checkbox-input').at(1).simulate('change');
    expect(onChangeGroup).not.toBeCalled();
  });

  it('does not prevent onChange callback from Checkbox when CheckboxGroup is not disabled', function () {
    var onChangeGroup = jest.fn();

    var options = [{ label: 'Apple', value: 'Apple' }, { label: 'Orange', value: 'Orange', disabled: true }];

    var groupWrapper = (0, _enzyme.mount)(_react2.default.createElement(_index2.default.Group, { options: options, onChange: onChangeGroup }));
    groupWrapper.find('.ant-checkbox-input').at(0).simulate('change');
    expect(onChangeGroup).toBeCalledWith(['Apple']);
    groupWrapper.find('.ant-checkbox-input').at(1).simulate('change');
    expect(onChangeGroup).toBeCalledWith(['Apple']);
  });
});