'use strict';

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

var _menu = require('../../menu');

var _menu2 = _interopRequireDefault(_menu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('DropdownButton', function () {
  it('pass appropriate props to Dropdown', function () {
    var props = {
      align: {
        offset: [10, 20]
      },
      overlay: _react2.default.createElement(
        _menu2.default,
        null,
        _react2.default.createElement(
          _menu2.default.Item,
          null,
          'foo'
        )
      ),
      trigger: ['hover'],
      visible: true,
      onVisibleChange: function onVisibleChange() {}
    };

    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_2.default.Button, props));
    var dropdownProps = wrapper.find(_2.default).props();

    (0, _keys2.default)(props).forEach(function (key) {
      expect(dropdownProps[key]).toBe(props[key]);
    });
  });

  it('don\'t pass visible to Dropdown if it\'s not exits', function () {
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_2.default.Button, null));
    var dropdownProps = wrapper.find(_2.default).props();

    expect('visible' in dropdownProps).toBe(false);
  });
});