'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

var _form = require('../../form');

var _form2 = _interopRequireDefault(_form);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TextArea = _2.default.TextArea;


var delay = function delay(timeout) {
  return new _promise2.default(function (resolve) {
    return setTimeout(resolve, timeout);
  });
};

describe('Input', function () {
  it('should support maxLength', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var wrapper;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(_2.default, { maxLength: '3' }));

            expect(wrapper).toMatchSnapshot();

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));
});

describe('TextArea', function () {
  it('should auto calculate height according to content length', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
    var wrapper, mockFunc;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(TextArea, { value: '', readOnly: true, autosize: true }));
            mockFunc = jest.spyOn(wrapper.node, 'resizeTextarea');

            wrapper.setProps({ value: '1111\n2222\n3333' });
            _context2.next = 5;
            return delay(0);

          case 5:
            expect(mockFunc).toHaveBeenCalledTimes(1);
            wrapper.setProps({ value: '1111' });
            _context2.next = 9;
            return delay(0);

          case 9:
            expect(mockFunc).toHaveBeenCalledTimes(2);

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  })));

  it('should support disabled', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
    var wrapper;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(TextArea, { disabled: true }));

            expect(wrapper).toMatchSnapshot();

          case 2:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  })));

  it('should support maxLength', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
    var wrapper;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(TextArea, { maxLength: '10' }));

            expect(wrapper).toMatchSnapshot();

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  })));
});

describe('As Form Control', function () {
  it('should be reset when wrapped in form.getFieldDecorator without initialValue', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
    var Demo, DemoForm, wrapper;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            Demo = function (_React$Component) {
              (0, _inherits3.default)(Demo, _React$Component);

              function Demo() {
                var _ref6;

                var _temp, _this, _ret;

                (0, _classCallCheck3.default)(this, Demo);

                for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = arguments[_key];
                }

                return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref6 = Demo.__proto__ || (0, _getPrototypeOf2.default)(Demo)).call.apply(_ref6, [this].concat(args))), _this), _this.reset = function () {
                  _this.props.form.resetFields();
                }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
              }

              (0, _createClass3.default)(Demo, [{
                key: 'render',
                value: function render() {
                  var getFieldDecorator = this.props.form.getFieldDecorator;

                  return _react2.default.createElement(
                    _form2.default,
                    null,
                    _react2.default.createElement(
                      _form2.default.Item,
                      null,
                      getFieldDecorator('input')(_react2.default.createElement(_2.default, null))
                    ),
                    _react2.default.createElement(
                      _form2.default.Item,
                      null,
                      getFieldDecorator('textarea')(_react2.default.createElement(_2.default.TextArea, null))
                    ),
                    _react2.default.createElement(
                      'button',
                      { onClick: this.reset },
                      'reset'
                    )
                  );
                }
              }]);
              return Demo;
            }(_react2.default.Component);

            DemoForm = _form2.default.create()(Demo);
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(DemoForm, null));

            wrapper.find('input').simulate('change', { target: { value: '111' } });
            wrapper.find('textarea').simulate('change', { target: { value: '222' } });
            expect(wrapper.find('input').prop('value')).toBe('111');
            expect(wrapper.find('textarea').prop('value')).toBe('222');
            wrapper.find('button').simulate('click');
            expect(wrapper.find('input').prop('value')).toBe('');
            expect(wrapper.find('textarea').prop('value')).toBe('');

          case 10:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  })));
});

describe('Input.Search', function () {
  it('should support suffix', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6() {
    var wrapper;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(_2.default.Search, { suffix: 'suffix' }));

            expect(wrapper).toMatchSnapshot();

          case 2:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, undefined);
  })));
});