'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

var _icon = require('../../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SubMenu = _2.default.SubMenu;

var delay = function delay(timeout) {
  return new _promise2.default(function (resolve) {
    return setTimeout(resolve, timeout);
  });
};

describe('Menu', function () {
  it('should accept defaultOpenKeys in mode horizontal', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { defaultOpenKeys: ['1'], mode: 'horizontal' },
      _react2.default.createElement(
        SubMenu,
        { key: '1', title: 'submenu1' },
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu1' },
          'Option 1'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu2' },
          'Option 2'
        )
      ),
      _react2.default.createElement(
        _2.default.Item,
        { key: '2' },
        'menu2'
      )
    ));
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
  });

  it('should accept defaultOpenKeys in mode inline', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { defaultOpenKeys: ['1'], mode: 'inline' },
      _react2.default.createElement(
        SubMenu,
        { key: '1', title: 'submenu1' },
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu1' },
          'Option 1'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu2' },
          'Option 2'
        )
      ),
      _react2.default.createElement(
        _2.default.Item,
        { key: '2' },
        'menu2'
      )
    ));
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
  });

  it('should accept defaultOpenKeys in mode vertical', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { defaultOpenKeys: ['1'], mode: 'vertical' },
      _react2.default.createElement(
        SubMenu,
        { key: '1', title: 'submenu1' },
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu1' },
          'Option 1'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu2' },
          'Option 2'
        )
      ),
      _react2.default.createElement(
        _2.default.Item,
        { key: '2' },
        'menu2'
      )
    ));
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
  });

  it('should accept openKeys in mode horizontal', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { openKeys: ['1'], mode: 'horizontal', openTransitionName: '' },
      _react2.default.createElement(
        SubMenu,
        { key: '1', title: 'submenu1' },
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu1' },
          'Option 1'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu2' },
          'Option 2'
        )
      ),
      _react2.default.createElement(
        _2.default.Item,
        { key: '2' },
        'menu2'
      )
    ));
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
    wrapper.setProps({ openKeys: [] });
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(true);
    wrapper.setProps({ openKeys: ['1'] });
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
  });

  it('should accept openKeys in mode inline', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { openKeys: ['1'], mode: 'inline', openAnimation: '' },
      _react2.default.createElement(
        SubMenu,
        { key: '1', title: 'submenu1' },
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu1' },
          'Option 1'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu2' },
          'Option 2'
        )
      ),
      _react2.default.createElement(
        _2.default.Item,
        { key: '2' },
        'menu2'
      )
    ));
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
    wrapper.setProps({ openKeys: [] });
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(true);
    wrapper.setProps({ openKeys: ['1'] });
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
  });

  it('should accept openKeys in mode vertical', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { openKeys: ['1'], mode: 'vertical', openTransitionName: '' },
      _react2.default.createElement(
        SubMenu,
        { key: '1', title: 'submenu1' },
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu1' },
          'Option 1'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu2' },
          'Option 2'
        )
      ),
      _react2.default.createElement(
        _2.default.Item,
        { key: '2' },
        'menu2'
      )
    ));
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
    wrapper.setProps({ openKeys: [] });
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(true);
    wrapper.setProps({ openKeys: ['1'] });
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
  });

  // https://github.com/ant-design/ant-design/pulls/4677
  // https://github.com/ant-design/ant-design/issues/4692
  // TypeError: Cannot read property 'indexOf' of undefined
  it('pr #4677 and issue #4692', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { mode: 'horizontal' },
      _react2.default.createElement(
        SubMenu,
        { title: 'submenu' },
        _react2.default.createElement(
          _2.default.Item,
          { key: '1' },
          'menu1'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: '2' },
          'menu2'
        )
      )
    ));
    wrapper.update();
    // just expect no error emit
  });

  it('should always follow openKeys when mode is switched', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { openKeys: ['1'], mode: 'inline' },
      _react2.default.createElement(
        SubMenu,
        { key: '1', title: 'submenu1' },
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu1' },
          'Option 1'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu2' },
          'Option 2'
        )
      ),
      _react2.default.createElement(
        _2.default.Item,
        { key: '2' },
        'menu2'
      )
    ));
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
    wrapper.setProps({ mode: 'vertical' });
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
    wrapper.setProps({ mode: 'inline' });
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
  });

  it('should always follow openKeys when mode is switched', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { defaultOpenKeys: ['1'], mode: 'inline' },
      _react2.default.createElement(
        _2.default.Item,
        { key: 'menu1' },
        _react2.default.createElement(_icon2.default, { type: 'inbox' }),
        _react2.default.createElement(
          'span',
          null,
          'Option'
        )
      ),
      _react2.default.createElement(
        SubMenu,
        { key: '1', title: 'submenu1' },
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu1' },
          'Option'
        ),
        _react2.default.createElement(
          _2.default.Item,
          { key: 'submenu2' },
          'Option'
        )
      )
    ));
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-inline')).toBe(true);
    expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(false);
    wrapper.setProps({ inlineCollapsed: true });
    setTimeout(function () {
      // 动画结束后套样式;
      expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-vertical')).toBe(true);
      expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(true);
      wrapper.setProps({ inlineCollapsed: false });
      expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-inline')).toBe(true);
      expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(false);
    }, 300);
  });

  it('should open submenu when click submenu title (inline)', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var wrapper;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(
              _2.default,
              { mode: 'inline' },
              _react2.default.createElement(
                SubMenu,
                { key: '1', title: 'submenu1' },
                _react2.default.createElement(
                  _2.default.Item,
                  { key: 'submenu1' },
                  'Option 1'
                ),
                _react2.default.createElement(
                  _2.default.Item,
                  { key: 'submenu2' },
                  'Option 2'
                )
              ),
              _react2.default.createElement(
                _2.default.Item,
                { key: '2' },
                'menu2'
              )
            ));

            expect(wrapper.find('.ant-menu-sub').length).toBe(0);
            wrapper.find('.ant-menu-submenu-title').simulate('click');
            expect(wrapper.find('.ant-menu-sub').length).toBe(1);
            expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
            wrapper.find('.ant-menu-submenu-title').simulate('click');
            _context.next = 8;
            return delay(300);

          case 8:
            expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(true);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  it('should open submenu when hover submenu title (vertical)', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
    var wrapper;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(
              _2.default,
              { mode: 'vertical' },
              _react2.default.createElement(
                SubMenu,
                { key: '1', title: 'submenu1' },
                _react2.default.createElement(
                  _2.default.Item,
                  { key: 'submenu1' },
                  'Option 1'
                ),
                _react2.default.createElement(
                  _2.default.Item,
                  { key: 'submenu2' },
                  'Option 2'
                )
              ),
              _react2.default.createElement(
                _2.default.Item,
                { key: '2' },
                'menu2'
              )
            ));

            expect(wrapper.find('.ant-menu-sub').length).toBe(0);
            wrapper.find('.ant-menu-submenu-title').simulate('mouseenter');
            expect(wrapper.find('.ant-menu-sub').length).toBe(1);
            expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
            wrapper.find('.ant-menu-submenu').simulate('mouseleave');
            _context2.next = 8;
            return delay(300);

          case 8:
            expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(true);

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  })));

  it('should open submenu when hover submenu title (horizontal)', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
    var wrapper;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(
              _2.default,
              { mode: 'horizontal' },
              _react2.default.createElement(
                SubMenu,
                { key: '1', title: 'submenu1' },
                _react2.default.createElement(
                  _2.default.Item,
                  { key: 'submenu1' },
                  'Option 1'
                ),
                _react2.default.createElement(
                  _2.default.Item,
                  { key: 'submenu2' },
                  'Option 2'
                )
              ),
              _react2.default.createElement(
                _2.default.Item,
                { key: '2' },
                'menu2'
              )
            ));

            expect(wrapper.find('.ant-menu-sub').length).toBe(0);
            wrapper.find('.ant-menu-submenu-title').simulate('mouseenter');
            expect(wrapper.find('.ant-menu-sub').length).toBe(1);
            expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).not.toBe(true);
            wrapper.find('.ant-menu-submenu').simulate('mouseleave');
            _context3.next = 8;
            return delay(300);

          case 8:
            expect(wrapper.find('.ant-menu-sub').at(0).hasClass('ant-menu-hidden')).toBe(true);

          case 9:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  })));
});