'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var delay = function delay(timeout) {
  return new _promise2.default(function (resolve) {
    return setTimeout(resolve, timeout);
  });
};

describe('message', function () {
  afterEach(function () {
    _2.default.destroy();
  });

  it('should be able to config top', function () {
    _2.default.config({
      top: 100
    });
    _2.default.info('whatever');
    expect(document.querySelectorAll('.ant-message')[0].style.top).toBe('100px');
  });

  it('should be able to config getContainer', function () {
    _2.default.config({
      getContainer: function getContainer() {
        var div = document.createElement('div');
        div.className = 'custom-container';
        document.body.appendChild(div);
        return div;
      }
    });
    _2.default.info('whatever');
    expect(document.querySelectorAll('.custom-container').length).toBe(1);
  });

  it('should be able to hide manually', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var hide1, hide2;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            hide1 = _2.default.info('whatever', 0);
            hide2 = _2.default.info('whatever', 0);

            expect(document.querySelectorAll('.ant-message-notice').length).toBe(2);
            hide1();
            _context.next = 6;
            return delay(100);

          case 6:
            expect(document.querySelectorAll('.ant-message-notice').length).toBe(1);
            hide2();
            _context.next = 10;
            return delay(100);

          case 10:
            expect(document.querySelectorAll('.ant-message-notice').length).toBe(0);

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  it('should be able to destroy globally', function () {
    _2.default.info('whatever', 0);
    _2.default.info('whatever', 0);
    expect(document.querySelectorAll('.ant-message').length).toBe(1);
    expect(document.querySelectorAll('.ant-message-notice').length).toBe(2);
    _2.default.destroy();
    expect(document.querySelectorAll('.ant-message').length).toBe(0);
    expect(document.querySelectorAll('.ant-message-notice').length).toBe(0);
  });
});