'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var confirm = _2.default.confirm;


describe('Modal.confirm triggers callbacks correctly', function () {
  var errorSpy = jest.spyOn(console, 'error').mockImplementation(function () {});

  afterEach(function () {
    errorSpy.mockReset();
  });

  afterAll(function () {
    errorSpy.mockRestore();
  });

  function $$(className) {
    return document.body.querySelectorAll(className);
  }

  function open(args) {
    confirm((0, _extends3.default)({
      title: 'Want to delete these items?',
      content: 'some descriptions'
    }, args));
  }

  it('trigger onCancel once when click on cancel button', function () {
    var onCancel = jest.fn();
    var onOk = jest.fn();
    open({
      onCancel: onCancel,
      onOk: onOk
    });
    // first Modal
    $$('.ant-btn')[0].click();
    expect(onCancel.mock.calls.length).toBe(1);
    expect(onOk.mock.calls.length).toBe(0);
  });

  it('trigger onOk once when click on ok button', function () {
    var onCancel = jest.fn();
    var onOk = jest.fn();
    open({
      onCancel: onCancel,
      onOk: onOk
    });
    // second Modal
    $$('.ant-btn-primary')[1].click();
    expect(onCancel.mock.calls.length).toBe(0);
    expect(onOk.mock.calls.length).toBe(1);
  });

  it('should allow Modal.comfirm without onCancel been set', function () {
    open();
    // Third Modal
    $$('.ant-btn')[4].click();
    expect(errorSpy).not.toHaveBeenCalled();
  });

  it('should allow Modal.comfirm without onOk been set', function () {
    open();
    // Fourth Modal
    $$('.ant-btn-primary')[3].click();
    expect(errorSpy).not.toHaveBeenCalled();
  });
});