'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Popconfirm', function () {
  it('should popup Popconfirm dialog', function () {
    var onVisibleChange = jest.fn();

    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      {
        title: _react2.default.createElement(
          'span',
          { className: 'popconfirm-test' },
          'Are you sure delete this task?'
        ),
        okText: 'Yes',
        cancelText: 'No',
        mouseEnterDelay: 0,
        mouseLeaveDelay: 0,
        onVisibleChange: onVisibleChange
      },
      _react2.default.createElement(
        'span',
        null,
        'Delete'
      )
    ));

    var triggerNode = wrapper.find('span').at(0);
    triggerNode.simulate('click');
    expect(onVisibleChange).toBeCalledWith(true);
    expect(document.querySelectorAll('.popconfirm-test').length).toBe(1);

    triggerNode.simulate('click');
    expect(onVisibleChange).toBeCalledWith(false);
  });

  it('should show overlay when trigger is clicked', function () {
    var popconfirm = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      { title: 'code' },
      _react2.default.createElement(
        'span',
        null,
        'show me your code'
      )
    ));

    expect(popconfirm.node.getPopupDomNode()).toBe(null);

    popconfirm.find('span').simulate('click');

    var popup = popconfirm.node.getPopupDomNode();
    expect(popup).not.toBe(null);
    expect(popup.className).toContain('ant-popover-placement-top');
    expect(popup.innerHTML).toMatchSnapshot();
    expect(popup.innerHTML).toMatchSnapshot();
  });
});