'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _radio = require('../radio');

var _radio2 = _interopRequireDefault(_radio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Radio', function () {
  it('should render correctly', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(
      _radio2.default,
      { className: 'customized' },
      'Test'
    ));
    expect(wrapper).toMatchSnapshot();
  });

  it('responses hover events', function () {
    var onMouseEnter = jest.fn();
    var onMouseLeave = jest.fn();

    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_radio2.default, {
      onMouseEnter: onMouseEnter,
      onMouseLeave: onMouseLeave
    }));

    wrapper.simulate('mouseenter');
    expect(onMouseEnter).toHaveBeenCalled();

    wrapper.simulate('mouseleave');
    expect(onMouseLeave).toHaveBeenCalled();
  });
});