'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Column = _2.default.Column,
    ColumnGroup = _2.default.ColumnGroup;


describe('Table', function () {
  it('renders JSX correctly', function () {
    var data = [{
      key: '1',
      firstName: 'John',
      lastName: 'Brown',
      age: 32
    }, {
      key: '2',
      firstName: 'Jim',
      lastName: 'Green',
      age: 42
    }];

    var wrapper = (0, _enzyme.render)(_react2.default.createElement(
      _2.default,
      { dataSource: data, pagination: false },
      _react2.default.createElement(
        ColumnGroup,
        { title: 'Name' },
        _react2.default.createElement(Column, {
          title: 'First Name',
          dataIndex: 'firstName',
          key: 'firstName'
        }),
        _react2.default.createElement(Column, {
          title: 'Last Name',
          dataIndex: 'lastName',
          key: 'lastName'
        })
      ),
      _react2.default.createElement(Column, {
        title: 'Age',
        dataIndex: 'age',
        key: 'age'
      })
    ));

    expect(wrapper).toMatchSnapshot();
  });

  it('updates columns when receiving props', function () {
    var columns = [{
      title: 'Name',
      key: 'name',
      dataIndex: 'name'
    }];
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_2.default, { columns: columns }));
    var newColumns = [{
      title: 'Title',
      key: 'title',
      dataIndex: 'title'
    }];
    wrapper.setProps({ columns: newColumns });

    expect(wrapper.instance().columns).toBe(newColumns);
  });

  it('loading with Spin', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var loading, wrapper;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            loading = {
              spinning: false,
              delay: 500
            };
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(_2.default, { loading: loading }));

            expect(wrapper.find('.ant-spin')).toHaveLength(0);

            loading.spinning = true;
            wrapper.setProps({ loading: loading });
            expect(wrapper.find('.ant-spin')).toHaveLength(0);

            _context.next = 8;
            return new _promise2.default(function (resolve) {
              return setTimeout(resolve, 500);
            });

          case 8:
            expect(wrapper.find('.ant-spin')).toHaveLength(1);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));
});