'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var columns = [{ title: 'Column 1', dataIndex: 'address', key: '1' }, { title: 'Column 2', dataIndex: 'address', key: '2' }, { title: 'Column 3', dataIndex: 'address', key: '3' }, { title: 'Column 4', dataIndex: 'address', key: '4' }, { title: 'Column 5', dataIndex: 'address', key: '5' }, { title: 'Column 6', dataIndex: 'address', key: '6' }, { title: 'Column 7', dataIndex: 'address', key: '7' }, { title: 'Column 8', dataIndex: 'address', key: '8' }];

var columnsFixed = [{
  title: 'Full Name', width: 100, dataIndex: 'name', key: 'name', fixed: 'left'
}, {
  title: 'Age', width: 100, dataIndex: 'age', key: 'age', fixed: 'left'
}, { title: 'Column 1', dataIndex: 'address', key: '1' }, { title: 'Column 2', dataIndex: 'address', key: '2' }, { title: 'Column 3', dataIndex: 'address', key: '3' }, { title: 'Column 4', dataIndex: 'address', key: '4' }, { title: 'Column 5', dataIndex: 'address', key: '5' }, { title: 'Column 6', dataIndex: 'address', key: '6' }, { title: 'Column 7', dataIndex: 'address', key: '7' }, { title: 'Column 8', dataIndex: 'address', key: '8' }, {
  title: 'Action',
  key: 'address',
  fixed: 'right',
  width: 100
}];

describe('Table', function () {
  it('renders empty table', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(_2.default, { dataSource: [], columns: columns, pagination: false }));
    expect(wrapper).toMatchSnapshot();
  });

  it('renders empty table with fixed columns', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(_2.default, { dataSource: [], columns: columnsFixed, pagination: false }));
    expect(wrapper).toMatchSnapshot();
  });

  it('renders empty table with custom emptyText', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(_2.default, {
      dataSource: [],
      columns: columns,
      pagination: false,
      locale: { emptyText: 'custom empty text ' }
    }));
    expect(wrapper).toMatchSnapshot();
  });
});