'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TabPane = _2.default.TabPane;


describe('Tabs', function () {
  describe('editable-card', function () {
    var handleEdit = void 0;
    var wrapper = void 0;

    beforeEach(function () {
      handleEdit = jest.fn();
      wrapper = (0, _enzyme.mount)(_react2.default.createElement(
        _2.default,
        { type: 'editable-card', onEdit: handleEdit },
        _react2.default.createElement(
          TabPane,
          { tab: 'foo', key: '1' },
          'foo'
        )
      ));
    });

    it('add card', function () {
      wrapper.find('.ant-tabs-new-tab').simulate('click');
      expect(handleEdit.mock.calls[0][1]).toBe('add');
    });

    it('remove card', function () {
      wrapper.find('.anticon-close').simulate('click');
      expect(handleEdit).toBeCalledWith('1', 'remove');
    });
  });

  describe('tabPosition', function () {
    it('remove card', function () {
      var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
        _2.default,
        { tabPosition: 'left', tabBarExtraContent: 'xxx' },
        _react2.default.createElement(
          TabPane,
          { tab: 'foo', key: '1' },
          'foo'
        )
      ));
      expect(wrapper).toMatchSnapshot();
    });
  });
});