'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var delay = function delay(timeout) {
  return new _promise2.default(function (resolve) {
    return setTimeout(resolve, timeout);
  });
};

describe('Tag', function () {
  it('should be closable', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var onClose, wrapper;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            onClose = jest.fn();
            wrapper = (0, _enzyme.mount)(_react2.default.createElement(_2.default, { closable: true, onClose: onClose }));

            expect(wrapper.find('.anticon-cross').length).toBe(1);
            expect(wrapper.find('.ant-tag').length).toBe(1);
            wrapper.find('.anticon-cross').simulate('click');
            expect(onClose).toBeCalled();
            _context.next = 8;
            return delay(500);

          case 8:
            expect(wrapper.find('.ant-tag').length).toBe(0);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  it('should not be closed when prevent default', (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
    var onClose, wrapper;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            onClose = function onClose(e) {
              e.preventDefault();
            };

            wrapper = (0, _enzyme.mount)(_react2.default.createElement(_2.default, { closable: true, onClose: onClose }));

            expect(wrapper.find('.anticon-cross').length).toBe(1);
            expect(wrapper.find('.ant-tag').length).toBe(1);
            wrapper.find('.anticon-cross').simulate('click');
            _context2.next = 7;
            return delay(500);

          case 7:
            expect(wrapper.find('.ant-tag').length).toBe(1);

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  })));
});