'use strict';

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _list = require('../list');

var _list2 = _interopRequireDefault(_list);

var _checkbox = require('../../checkbox');

var _checkbox2 = _interopRequireDefault(_checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var listCommonProps = {
  prefixCls: 'ant-transfer-list',
  dataSource: [{
    key: 'a',
    title: 'a'
  }, {
    key: 'b',
    title: 'b'
  }, {
    key: 'c',
    title: 'c',
    disabled: true
  }],
  checkedKeys: ['a'],
  notFoundContent: 'Not Found',
  lazy: false
};

describe('List', function () {
  it('should render correctly', function () {
    var wrapper = (0, _enzyme.render)(_react2.default.createElement(_list2.default, listCommonProps));
    expect(wrapper).toMatchSnapshot();
  });

  it('should check top Checkbox while all available items are checked', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_list2.default, (0, _extends3.default)({}, listCommonProps, { checkedKeys: ['a', 'b'] })));
    expect(wrapper.find('.ant-transfer-list-header').find(_checkbox2.default).prop('checked')).toBeTruthy();
  });
});