'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Upload', function () {
  // https://github.com/react-component/upload/issues/36
  it('should get refs inside Upload in componentDidMount', function () {
    var ref = void 0;

    var App = function (_React$Component) {
      (0, _inherits3.default)(App, _React$Component);

      function App() {
        (0, _classCallCheck3.default)(this, App);
        return (0, _possibleConstructorReturn3.default)(this, (App.__proto__ || (0, _getPrototypeOf2.default)(App)).apply(this, arguments));
      }

      (0, _createClass3.default)(App, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          ref = this.refs.input;
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(
            _2.default,
            { supportServerRender: false },
            _react2.default.createElement('input', { ref: 'input' })
          );
        }
      }]);
      return App;
    }(_react2.default.Component);

    (0, _enzyme.mount)(_react2.default.createElement(App, null));
    expect(ref).toBeDefined();
  });

  it('return promise in beforeUpload', function (done) {
    var data = jest.fn();
    var props = {
      action: 'http://upload.com',
      beforeUpload: function beforeUpload() {
        return new _promise2.default(function (resolve) {
          return setTimeout(function () {
            return resolve('success');
          }, 1000);
        });
      },
      data: data,
      onChange: function onChange(_ref) {
        var file = _ref.file;

        if (file.status !== 'uploading') {
          expect(data).toBeCalled();
          done();
        }
      }
    };

    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      props,
      _react2.default.createElement(
        'button',
        null,
        'upload'
      )
    ));

    wrapper.find('input').simulate('change', {
      target: {
        files: [{ filename: 'foo.png' }]
      }
    });
  });

  it('should not stop upload when return value of beforeUpload is not false', function (done) {
    var data = jest.fn();
    var props = {
      action: 'http://upload.com',
      beforeUpload: function beforeUpload() {
        return false;
      },
      data: data,
      onChange: function onChange() {
        expect(data).not.toBeCalled();
        done();
      }
    };

    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      props,
      _react2.default.createElement(
        'button',
        null,
        'upload'
      )
    ));

    wrapper.find('input').simulate('change', {
      target: {
        files: [{ filename: 'foo.png' }]
      }
    });
  });

  it('should not stop upload when return value of beforeUpload is not false', function (done) {
    var data = jest.fn();
    var props = {
      action: 'http://upload.com',
      beforeUpload: function beforeUpload() {},

      data: data,
      onChange: function onChange() {
        expect(data).toBeCalled();
        done();
      }
    };

    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _2.default,
      props,
      _react2.default.createElement(
        'button',
        null,
        'upload'
      )
    ));

    wrapper.find('input').simulate('change', {
      target: {
        files: [{ filename: 'foo.png' }]
      }
    });
  });
}); /* eslint-disable react/no-string-refs, react/prefer-es6-class */