'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = CustomizedHOCForm;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _asyncValidator = require('async-validator');

var _asyncValidator2 = _interopRequireDefault(_asyncValidator);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// imported from flattenJS (Thanks richie5um) https://github.com/richie5um/FlattenJS/blob/master/lib/flatten.js
var convert = function convert(obj) {
  return _lodash2.default.transform(obj, function (result, value, key) {
    if (_moment2.default.isMoment(value)) {
      result[key] = value;
    } else if (_lodash2.default.isObject(value)) {
      if (_lodash2.default.isArray(value)) {
        result[key] = value;
      }
      var flatMap = _lodash2.default.mapKeys(convert(value), function (mvalue, mkey) {
        if (_lodash2.default.isArray(value)) {
          var index = mkey.indexOf('.');
          if (index !== -1) {
            return key + '[' + mkey.slice(0, index) + ']' + mkey.slice(index);
          }
          return key + '[' + mkey + ']';
        }
        return key + '.' + mkey;
      });
      _lodash2.default.assign(result, flatMap);
    } else if (value !== undefined) {
      result[key] = value;
    }
    return result;
  }, {});
};

var getParams = function getParams(ns, opt, cb) {
  var names = ns;
  var options = opt;
  var callback = cb;
  if (cb === undefined) {
    if (typeof names === 'function') {
      callback = names;
      options = {};
      names = undefined;
    } else if (Array.isArray(names)) {
      if (typeof options === 'function') {
        callback = options;
        options = {};
      } else {
        options = options || {};
      }
    } else {
      callback = options;
      options = names || {};
      names = undefined;
    }
  }
  return {
    names: names,
    options: options,
    callback: callback
  };
};

var dateTimeFormat = 'YYYY-MM-DD HH:mm:ss';

var validateFields = function validateFields(_ref) {
  var values = _ref.values,
      rules = _ref.rules,
      _ref$options = _ref.options,
      options = _ref$options === undefined ? {
    force: true
  } : _ref$options;

  var validator = new _asyncValidator2.default(rules);
  var formErrors = null;
  validator.validate(values, options, function (errors) {
    formErrors = errors;
  });
  if (formErrors) {
    return formErrors;
  } else {
    // if (callback) {
    // callback(null, getFieldsValue())
    // } else {
    //     return null
    // }
    return null;
  }
};

function CustomizedHOCForm(_ref2) {
  var _ref2$onFieldsChange = _ref2.onFieldsChange,
      onFieldsChange = _ref2$onFieldsChange === undefined ? function () {} : _ref2$onFieldsChange,
      mapPropsToFields = _ref2.mapPropsToFields,
      onValuesChange = _ref2.onValuesChange,
      helpPosition = _ref2.helpPosition,
      _ref2$prefixClass = _ref2.prefixClass,
      prefixClass = _ref2$prefixClass === undefined ? 'ant-form' : _ref2$prefixClass;

  var isScrolled = false;
  var store = {
    fieldsIds: [],
    fields: {}
  };
  var updateQueue = {};
  return function (WrappedComponent) {
    return function (_React$Component) {
      (0, _inherits3.default)(_class2, _React$Component);

      function _class2(props) {
        (0, _classCallCheck3.default)(this, _class2);

        var _this2 = (0, _possibleConstructorReturn3.default)(this, (_class2.__proto__ || (0, _getPrototypeOf2.default)(_class2)).call(this, props));

        _this2.resetFields = function () {
          var fieldsIds = store.fieldsIds,
              fields = store.fields;

          var fieldsObject = {};
          fieldsIds.forEach(function (id) {
            var field = _lodash2.default.result(fields, id);
            if (field && field.setFieldValue) {
              var initialValue = field.initialValue;

              var value = initialValue || initialValue === false || initialValue === 0 ? initialValue : '';
              field.setFieldValue(value, {
                needCallback: false,
                needValidate: false,
                clearValidate: true
              });
              fieldsObject[id] = { value: value, initialValue: initialValue };
            }
          });
          if (onFieldsChange && (0, _keys2.default)(fieldsObject).length > 0) {
            onFieldsChange(_this2.props, fieldsObject);
          }
          store.fieldsIds = [];
          store.fields = {};
        };

        _this2.getFieldValue = function (id) {
          var fields = store.fields;

          var field = _lodash2.default.result(fields, id);
          if (field && field.setFieldValue && field.isExist && field.isExist()) {
            return _lodash2.default.result(fields, id + '.value');
          }
          return undefined;
        };

        _this2.getFieldValueWithoutMount = function (id) {
          var fields = store.fields;

          var field = _lodash2.default.result(fields, id);
          if (field) {
            return _lodash2.default.result(fields, id + '.value');
          }
          return undefined;
        };

        _this2.setFieldsValue = function (data) {
          var needValidate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
          var fields = store.fields;

          var flattenedObject = convert(data);
          var fieldsObject = {};
          (0, _keys2.default)(flattenedObject).forEach(function (key) {
            if (key.endsWith('.value')) {
              _lodash2.default.set(fields, key, flattenedObject[key]);
            } else {
              _lodash2.default.set(fields, key + '.value', flattenedObject[key]);
            }
            var field = _lodash2.default.result(fields, key.replace('.value', ''), {});

            if (field.setFieldValue) {
              field.setFieldValue(field.value, { needCallback: false, needValidate: needValidate, clearValidate: !needValidate });
            }
            fieldsObject[key.replace('.value', '')] = { value: flattenedObject[key] };
          });
          if (onFieldsChange && (0, _keys2.default)(fieldsObject).length > 0) {
            onFieldsChange(_this2.props, fieldsObject);
          }
        };

        _this2.setFields = function (data) {
          var needValidate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

          _this2.setFieldsValue(data, needValidate);
        };

        _this2.getFieldsValue = function (names) {
          var formatDate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
          var fieldsIds = store.fieldsIds;

          var fieldNames = names || fieldsIds;
          var _this = _this2,
              result = {};
          fieldNames.forEach(function (name) {
            var value = _this.getFieldValue(name);
            if (value !== undefined) {
              if (formatDate && _moment2.default.isMoment(value)) {
                value = value.format(dateTimeFormat);
              }
              _lodash2.default.set(result, name, value);
            }
          });
          return result;
        };

        _this2.getFieldDecorator = function (id) {
          var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
          var fields = store.fields,
              fieldsIds = store.fieldsIds;
          var initialValue = options.initialValue,
              _options$valuePropNam = options.valuePropName,
              valuePropName = _options$valuePropNam === undefined ? 'value' : _options$valuePropNam,
              rules = options.rules,
              otherProps = (0, _objectWithoutProperties3.default)(options, ['initialValue', 'valuePropName', 'rules']);

          if (_lodash2.default.result(fields, id) === undefined) {
            _lodash2.default.set(fields, '' + id, {});
          }
          if (initialValue !== undefined) {
            _lodash2.default.set(fields, id + '.initialValue', initialValue);
          }
          if (fieldsIds.indexOf(id) < 0) {
            fieldsIds.push(id);
          }
          if (rules) {
            _lodash2.default.set(fields, id + '.rules', rules);
          }
          var getFieldError = _this2.getFieldError;
          var outerProps = _this2.props;
          var getFields = function getFields() {
            return fields;
          };
          var removeField = _this2.removeField;
          if (Array.isArray(updateQueue[id])) {
            updateQueue[id].push(1);
          } else {
            updateQueue[id] = [1];
          }
          var getQueue = function getQueue() {
            return updateQueue[id];
          };
          return function (ReactElement) {
            return _react2.default.createElement(WrappedField, (0, _extends3.default)({
              key: id,
              prefixClass: prefixClass
            }, ReactElement.props, {
              id: id,
              removeField: removeField,
              getFields: getFields,
              valuePropName: valuePropName,
              ReactElement: ReactElement,
              onFieldsChange: onFieldsChange,
              getFieldError: getFieldError,
              outerProps: outerProps,
              formHelpPosition: helpPosition,
              getQueue: getQueue
            }, otherProps));
          };
        };

        _this2.removeField = function (id) {
          delete store.fields[id];
          store.fieldsIds = store.fieldsIds.filter(function (i) {
            return id !== i;
          });
        };

        _this2.validateWithoutFieldsAndScroll = function (ns, opt, cb) {
          isScrolled = false;

          var _getParams = getParams(ns, opt, cb),
              _getParams$names = _getParams.names,
              names = _getParams$names === undefined ? [] : _getParams$names,
              callback = _getParams.callback,
              options = _getParams.options;

          var fields = store.fields,
              fieldsIds = store.fieldsIds;

          var errors = {},
              removedIds = [];
          var validateFieldsIds = fieldsIds.filter(function (id) {
            return names.indexOf(id) < 0;
          });
          validateFieldsIds.forEach(function (id) {
            var field = _lodash2.default.result(fields, id);
            if (field && field.validate) {
              var error = field.validate(true, isScrolled);
              if (error && error !== 'needRemove') {
                isScrolled = true;
              }
              if (error === 'needRemove') {
                removedIds.push(id);
              } else {
                errors = _lodash2.default.merge(errors, error);
              }
            }
          });
          validateFieldsIds = validateFieldsIds.filter(function (i) {
            return removedIds.indexOf(i) < 0;
          });
          var values = _this2.getFieldsValue(validateFieldsIds, true);
          if (typeof callback === 'function') {
            if (_lodash2.default.keys(errors).length < 1) {
              errors = null;
            }
            callback(errors, values);
          }
        };

        _this2.validateFieldsAndScroll = function (ns, opt, cb) {
          isScrolled = false;
          var fields = store.fields,
              fieldsIds = store.fieldsIds;

          var _getParams2 = getParams(ns, opt, cb),
              _getParams2$names = _getParams2.names,
              names = _getParams2$names === undefined ? fieldsIds : _getParams2$names,
              callback = _getParams2.callback,
              options = _getParams2.options;

          var errors = {},
              removedIds = [];
          names.forEach(function (id) {
            var field = _lodash2.default.result(fields, id);
            if (field && field.validate) {
              var error = field.validate(true, isScrolled);
              if (error && error !== 'needRemove') {
                isScrolled = true;
              }
              if (error === 'needRemove') {
                removedIds.push(id);
              } else {
                errors = _lodash2.default.merge(errors, error);
              }
            }
          });
          names = fieldsIds.filter(function (i) {
            return removedIds.indexOf(i) < 0;
          });
          fields = _lodash2.default.omit(fields, removedIds);
          var values = _this2.getFieldsValue(names, true);
          if (typeof callback === 'function') {
            if (_lodash2.default.keys(errors).length < 1) {
              errors = null;
            }
            callback(errors, values);
          }
        };

        _this2.getFieldError = function (id) {
          var fields = store.fields;

          var field = _lodash2.default.result(fields, id);
          if (!field) {
            return;
          }
          var values = {};

          if (!field.rules) {
            return;
          }

          var isRequireed = Array.isArray(field.rules) && field.rules.some(function (o) {
            return o.required;
          });

          if ('value' in field) {
            values[id] = field.value;
          } else if (!isRequireed) {
            return;
          }

          var rules = {};
          rules[id] = field.rules;
          var error = validateFields({ values: values, rules: rules });
          if (error && error.length > 0) {
            var message = '';
            error.forEach(function (i) {
              message += i.message;
            });
            return { message: message, id: id };
          } else {
            return null;
          }
        };

        _this2.validateField = function (id) {
          var fields = store.fields;

          var field = _lodash2.default.result(fields, id);
          return field.validate();
        };

        return _this2;
      }

      (0, _createClass3.default)(_class2, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          if (mapPropsToFields && typeof mapPropsToFields === 'function') {
            this.currentResult = mapPropsToFields(this.props);
            this.setFieldsValue(this.currentResult);
          }
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          if (mapPropsToFields && typeof mapPropsToFields === 'function') {
            var nextResult = mapPropsToFields(nextProps);
            if (!_lodash2.default.isEqual(nextResult, this.currentResult)) {
              this.setFieldsValue(nextResult);
              this.currentResult = nextResult;
            }
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _props = this.props,
              wrappedComponentRef = _props.wrappedComponentRef,
              props = (0, _objectWithoutProperties3.default)(_props, ['wrappedComponentRef']);

          var formProps = {
            getFieldDecorator: this.getFieldDecorator,
            resetFields: this.resetFields,
            getFieldValue: this.getFieldValue,
            setFieldsValue: this.setFieldsValue,
            validateFieldsAndScroll: this.validateFieldsAndScroll,
            getFieldError: this.getFieldError,
            setFields: this.setFields,
            getFieldsValue: this.getFieldsValue,
            validateField: this.validateField,
            validateWithoutFieldsAndScroll: this.validateWithoutFieldsAndScroll,
            getFieldValueWithoutMount: this.getFieldValueWithoutMount
          };
          var ref = {};
          if (wrappedComponentRef) {
            ref = wrappedComponentRef;
          }
          return _react2.default.createElement(WrappedComponent, (0, _extends3.default)({ ref: ref, form: (0, _extends3.default)({}, formProps) }, props));
        }
      }]);
      return _class2;
    }(_react2.default.Component);
  };
}

var WrappedField = function (_React$Component2) {
  (0, _inherits3.default)(WrappedField, _React$Component2);

  function WrappedField(props) {
    (0, _classCallCheck3.default)(this, WrappedField);

    var _this3 = (0, _possibleConstructorReturn3.default)(this, (WrappedField.__proto__ || (0, _getPrototypeOf2.default)(WrappedField)).call(this, props));

    _initialiseProps.call(_this3);

    var fields = props.getFields();
    var field = _lodash2.default.result(fields, props.id);
    var valuePropName = props.valuePropName;
    var value = field.initialValue;
    if ('value' in field) {
      value = field.value;
    }
    if (field.value === undefined) {
      field.value = value;
    }
    _this3.state = {
      value: value
    };
    _this3.delay = null;
    return _this3;
  }

  (0, _createClass3.default)(WrappedField, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._ismounted = true;
      this.initField(this.props);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._ismounted = false;
      if (this.props.getQueue().length === 1) {
        this.props.removeField(this.props.id);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var fields = nextProps.getFields();
      var field = _lodash2.default.result(fields, nextProps.id);
      if (!field.setFieldValue) {
        this.initField(nextProps);
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var omitList = this.getOmitFields(nextProps);
      if (_lodash2.default.isEqual(_lodash2.default.omit(nextProps, omitList), _lodash2.default.omit(this.props, omitList)) && _lodash2.default.isEqual(nextState, this.state)) {
        return false;
      } else {
        return true;
      }
    }
  }, {
    key: 'renderHelp',
    value: function renderHelp(help) {
      var prefixCls = 'ant-form';
      var position = '';
      if (this.props.formHelpPosition) {
        position = '-' + this.props.formHelpPosition;
      }
      if (this.props.helpPosition) {
        position = '-' + this.props.helpPosition;
      }
      return _react2.default.createElement('div', { className: prefixCls + '-explain' + position, key: 'help', id: this.props.id + '-explain' }, help);
    }
  }, {
    key: 'render',


    // onSearch = (value) => {
    // 	this.props.onSearch && this.props.onSearch(value)
    // }

    value: function render() {
      var props = {
        onChange: this.onChange,
        value: this.state.value,
        id: this.props.id,
        key: this.props.id
      };
      // if (this.props.onSearch) {
      // 	props.onSearch = this.onSearch
      // }
      var valuePropName = this.props.valuePropName;
      if (valuePropName !== 'value') {
        props[valuePropName] = this.state.value;
        delete props.value;
      }
      return _react2.default.cloneElement(this.props.ReactElement, (0, _extends3.default)({}, props));
    }
  }]);
  return WrappedField;
}(_react2.default.Component);

var _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.isRequired = function (rules) {
    return rules && rules.some(function (rule) {
      return rule.required;
    });
  };

  this.initField = function (props) {
    var fields = props.getFields();
    var field = _lodash2.default.result(fields, props.id);
    var valuePropName = props.valuePropName;
    var value = field.initialValue;
    if ('value' in field) {
      value = field.value;
    }
    if (field.value === undefined) {
      field.value = value;
    }
    field.setFieldValue = function (value, _ref3) {
      var _ref3$needCallback = _ref3.needCallback,
          needCallback = _ref3$needCallback === undefined ? true : _ref3$needCallback,
          _ref3$needValidate = _ref3.needValidate,
          needValidate = _ref3$needValidate === undefined ? true : _ref3$needValidate,
          _ref3$clearValidate = _ref3.clearValidate,
          clearValidate = _ref3$clearValidate === undefined ? false : _ref3$clearValidate;

      var result = {
        target: {
          id: props.id
        }
      };
      result.target[valuePropName] = value;
      if (_moment2.default.isMoment(value)) {
        result = value;
      }
      _this4.onChange(result, {
        needCallback: needCallback,
        needValidate: needValidate,
        clearValidate: clearValidate
      });
    };
    field.validate = _this4.validate;
    var required = _this4.isRequired(field.rules);
    if (required) {
      _this4.setRequired();
    }
    _this4.setState({
      value: value,
      required: required
    });
    field.isExist = _this4.isExist;
  };

  this.getOmitFields = function (props) {
    var list = [];
    (0, _keys2.default)(props).forEach(function (key) {
      if (typeof props[key] === 'function') {
        list.push(key);
      }
    });
    return list;
  };

  this.isExist = function () {
    return _this4._ismounted;
    try {
      var selfNode = _reactDom2.default.findDOMNode(_this4);
      return true;
    } catch (e) {
      return false;
    }
  };

  this.setRequired = function () {
    try {
      var selfNode = _reactDom2.default.findDOMNode(_this4);
      var parentElement = selfNode.parentElement;
      if (parentElement) {
        (0, _jquery2.default)((0, _jquery2.default)(parentElement.offsetParent).find('.' + _this4.props.prefixClass + '-item-label label')).attr('class', _this4.props.prefixClass + '-item-required');
      }
    } catch (e) {}
  };

  this.validate = function () {
    var needScroll = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var isScrolled = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

    var error = _this4.props.getFieldError(_this4.props.id);
    var selfNode = void 0;
    try {
      selfNode = _reactDom2.default.findDOMNode(_this4);
    } catch (e) {
      return 'needRemove';
    }
    var parentElement = selfNode.parentElement;
    var $parent = void 0;
    if (parentElement) {
      $parent = (0, _jquery2.default)(parentElement);
    }
    if (error) {
      if ($parent) {
        if (!isScrolled) {
          parentElement.scrollIntoView();
        }
        var explain = parentElement.querySelector('[id=\'' + _this4.props.id + '-explain\']');
        if (explain) {
          return error;
        }
        $parent.removeClass('has-success');
        $parent.addClass('has-error');
        var prefixCls = 'ant-form';
        var div = document.createElement('div');
        selfNode.parentNode.appendChild(_reactDom2.default.render(_this4.renderHelp(error.message), div));
        div.remove();
      }
    } else {
      if ($parent) {
        $parent.removeClass('has-error');
        $parent.addClass('has-success');
        var _explain = parentElement.querySelector('[id=\'' + _this4.props.id + '-explain\']');
        if (_explain) {
          _explain.remove();
        }
      }
    }
    return error;
  };

  this.clearValidate = function () {
    var selfNode = void 0;
    try {
      selfNode = _reactDom2.default.findDOMNode(_this4);
    } catch (e) {
      return;
    }
    var parentElement = selfNode.parentElement;
    var $parent = void 0;
    if (parentElement) {
      $parent = (0, _jquery2.default)(parentElement);
    }
    if ($parent) {
      $parent.removeClass('has-error');
      $parent.addClass('has-success');
      var explain = parentElement.querySelector('[id=\'' + _this4.props.id + '-explain\']');
      if (explain) {
        explain.remove();
      }
    }
  };

  this.onChange = function () {
    for (var _len = arguments.length, rest = Array(_len), _key = 0; _key < _len; _key++) {
      rest[_key] = arguments[_key];
    }

    var e = rest[0],
        _rest$ = rest[1];
    _rest$ = _rest$ === undefined ? { needCallback: true, needValidate: true, clearValidate: false } : _rest$;
    var needCallback = _rest$.needCallback,
        needValidate = _rest$.needValidate,
        clearValidate = _rest$.clearValidate;

    if (!_this4._ismounted) {
      return;
    }
    var fields = _this4.props.getFields();
    var field = _lodash2.default.result(fields, _this4.props.id);
    var valuePropName = _this4.props.valuePropName;
    if (e && (typeof e === 'string' || !e.target || _moment2.default.isMoment(e))) {
      field.value = e;
    } else if (e) {
      field.value = e.target[valuePropName];
    } else {
      field.value = '';
    }
    if (_this4.props.getValueFromEvent && typeof _this4.props.getValueFromEvent === 'function') {
      field.value = _this4.props.getValueFromEvent(field.value);
    }
    if (needValidate || needValidate === undefined) {
      _this4.validate();
    }
    if (clearValidate) {
      _this4.clearValidate();
    }
    if (_lodash2.default.isEqual(field.value, _this4.state.value)) {
      return;
    }
    _this4.setState({
      value: field.value
    });
    var onFieldsChange = _this4.props.onFieldsChange;
    if (onFieldsChange && (needCallback || needCallback === undefined)) {
      var fieldsObject = {};
      fieldsObject[_this4.props.id] = {
        value: field.value
      };
      var outerProps = _this4.props.outerProps;
      if (outerProps.dispatch) {
        if (_this4.delay) {
          clearTimeout(_this4.delay);
          _this4.delay = null;
        }
        _this4.delay = setTimeout(function () {
          return onFieldsChange(outerProps, fieldsObject);
        }, 300);
      } else {
        onFieldsChange(outerProps, fieldsObject);
      }
    }
    if (_this4.props.onChange) {
      var _props2;

      (_props2 = _this4.props).onChange.apply(_props2, rest);
    }
  };
};

module.exports = exports['default'];