'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../button/index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function FloatDragComponent() {
  var option = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    top: 5,
    right: 5,
    id: 'suspension-drag-component'
  };
  var WrappedComponent = arguments[1];

  var DragComponent = function (_React$Component) {
    (0, _inherits3.default)(DragComponent, _React$Component);

    function DragComponent(props) {
      (0, _classCallCheck3.default)(this, DragComponent);

      var _this = (0, _possibleConstructorReturn3.default)(this, (DragComponent.__proto__ || (0, _getPrototypeOf2.default)(DragComponent)).call(this, props));

      _this.self = {
        offsetX: 0,
        offsetY: 0,
        offsetWidth: 0,
        offsetHeight: 0
      };

      _this.onDragstart = function (e) {
        _this.self.offsetX = e.offsetX;
        _this.self.offsetY = e.offsetY;
      };

      _this.onDragend = function (e) {
        var ref = _this.refs[option.id];
        var _this$state = _this.state,
            top = _this$state.top,
            right = _this$state.right;
        var _this$self = _this.self,
            offsetX = _this$self.offsetX,
            offsetY = _this$self.offsetY,
            offsetWidth = _this$self.offsetWidth,
            offsetHeight = _this$self.offsetHeight;

        var _top = top + (e.offsetY - offsetY);
        if (_top < 0) {
          _top = 0;
        } else if (_top > offsetHeight - ref.clientHeight) {
          _top = offsetHeight - ref.clientHeight;
        }
        var _right = right - (e.offsetX - offsetX);
        if (_right < 0) {
          _right = 0;
        } else if (_right > offsetWidth - ref.clientWidth) {
          _right = offsetWidth - ref.clientWidth;
        }
        _this.setState({ top: _top, right: _right });
        _this.self.offsetX = 0;
        _this.self.offsetY = 0;
      };

      _this.jumpToCustomizedPage = function (e) {
        if (option.url) {
          window.open(option.url);
        }
      };

      _this.state = {
        top: option.top || 5,
        right: option.right || 5
      };
      _this.self.offsetWidth = document.body.offsetWidth;
      _this.self.offsetHeight = document.body.offsetHeight;
      return _this;
    }

    (0, _createClass3.default)(DragComponent, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var ref = this.refs[option.id];
        if (ref) {
          ref.addEventListener("dragstart", this.onDragstart, false);
          ref.addEventListener("dragend", this.onDragend, false);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _state = this.state,
            top = _state.top,
            right = _state.right;

        return _react2.default.createElement(
          'div',
          { id: option.id, ref: option.id, draggable: 'true', style: { zIndex: 100, position: 'fixed', top: top, right: right } },
          WrappedComponent != null ? _react2.default.createElement(
            'div',
            { style: { width: option.width || 200 } },
            WrappedComponent
          ) : _react2.default.createElement(
            _index2.default,
            { onClick: option.onClick || this.jumpToCustomizedPage },
            option.buttonLabel || '自定义页面布局'
          )
        );
      }
    }]);
    return DragComponent;
  }(_react2.default.Component);

  return _react2.default.createElement(DragComponent, null);
}

exports.default = { FloatDragComponent: FloatDragComponent };
module.exports = exports['default'];