'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _style3 = require('../../antd/dropdown/style');

var _dropdown = require('../../antd/dropdown');

var _dropdown2 = _interopRequireDefault(_dropdown);

var _style4 = require('../../antd/input/style');

var _input = require('../../antd/input');

var _input2 = _interopRequireDefault(_input);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _rcMenu = require('rc-menu');

var _rcMenu2 = _interopRequireDefault(_rcMenu);

var _KeyCode = require('rc-util/lib/KeyCode');

var _KeyCode2 = _interopRequireDefault(_KeyCode);

require('./styles/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//props selectKey 指定一个key的值填入input中
var MultiColSelect = function (_Component) {
    (0, _inherits3.default)(MultiColSelect, _Component);

    function MultiColSelect(props) {
        (0, _classCallCheck3.default)(this, MultiColSelect);

        var _this = (0, _possibleConstructorReturn3.default)(this, (MultiColSelect.__proto__ || (0, _getPrototypeOf2.default)(MultiColSelect)).call(this, props));

        _initialiseProps.call(_this);

        _this.state = {
            val: "",
            optionList: {},
            open: false,
            selectKeys: ['-1'],
            activeKey: '0',
            canMenuHide: true
        };
        return _this;
    }

    //失焦


    (0, _createClass3.default)(MultiColSelect, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                dataHeader = _props.dataHeader,
                disabled = _props.disabled,
                dataBody = _props.dataBody,
                _onBlur = _props.onBlur,
                type = _props.type,
                rows = _props.rows,
                autosize = _props.autosize,
                props = (0, _objectWithoutProperties3.default)(_props, ['dataHeader', 'disabled', 'dataBody', 'onBlur', 'type', 'rows', 'autosize']);

            var hasDataBody = dataBody && dataBody.length > 0;
            var dropdownHeadData = dataHeader,
                dropdownBodyData = hasDataBody ? dataBody : "not found";

            // 拼接下拉框header部分结构
            var dropdownHeadElement = dropdownHeadData ? _react2.default.createElement(
                _rcMenu.MenuItem,
                { key: 'title', disabled: true },
                dropdownHeadData.map(function (val) {
                    return _react2.default.createElement(
                        'p',
                        {
                            key: val.dataIndex },
                        val.title
                    );
                })
            ) : '';
            var dropdownBodyElement = !hasDataBody ? _react2.default.createElement(
                _rcMenu.MenuItem,
                { className: 'no-data', disabled: true },
                _react2.default.createElement(
                    'p',
                    { colSpan: '2' },
                    dropdownBodyData
                ),
                _react2.default.createElement('p', null)
            ) : createBodyElement();
            //下拉框body部分
            function createBodyElement() {
                var isArray = dropdownBodyData instanceof Array;
                if (!isArray) {
                    throw new TypeError('MultiColSelect 组件的 dataBody 只接受 "Array" 格式的数据');
                }

                return dropdownBodyData.map(function (val, index) {
                    var parentVal = val;
                    var _item = dropdownHeadData.map(function (val, i) {
                        return _react2.default.createElement(
                            'p',
                            { key: i },
                            parentVal[val.dataIndex]
                        );
                    });
                    return _react2.default.createElement(
                        _rcMenu.MenuItem,
                        { key: index },
                        _item
                    ); //这里的key可以当value使用，不用再定义value
                });
            }

            var dropdwonMaxHeight = (props.dropdwonMaxRows + 1) * this.props.scrollHeight;
            var dropdwonStyle = props.dropdwonMaxRows && { maxHeight: dropdwonMaxHeight };

            return _react2.default.createElement(
                _dropdown2.default,
                { overlay: _react2.default.createElement(
                        'div',
                        {
                            className: 'o-dropdown-multi-col',
                            ref: 'menu',
                            style: dropdwonStyle,
                            onMouseEnter: this.handleMenuMouseEnter,
                            onMouseLeave: this.handleMenuMouseLeave
                        },
                        _react2.default.createElement(
                            _rcMenu2.default,
                            {
                                onSelect: this.onMenuSelect,
                                activeKey: this.state.activeKey,
                                selectedKeys: this.state.selectKeys
                            },
                            dropdownHeadElement,
                            dropdownBodyElement
                        )
                    ),
                    visible: this.state.open

                },
                _react2.default.createElement(_input2.default, {
                    ref: 'input',
                    type: type,
                    value: props.value,
                    rows: rows,
                    autosize: autosize,
                    onClick: this.handleClick,
                    onChange: this.handleChange,
                    onKeyDown: this.onKeyDown,
                    onBlur: function onBlur() {
                        return _this2.handleBlur(_onBlur);
                    },
                    disabled: disabled
                })
            );
        }
    }]);
    return MultiColSelect;
}(_react.Component);
// const MenuItem = Menu.Item;


MultiColSelect.propTypes = {
    dataBody: _react2.default.PropTypes.array,
    dataHead: _react2.default.PropTypes.object,
    dropdwonMaxRows: _react2.default.PropTypes.number

};
MultiColSelect.defaultProps = {
    selectKey: "value",
    disabled: false,
    scrollHeight: 32
};

var _initialiseProps = function _initialiseProps() {
    var _this3 = this;

    this.scrollTo = function (index) {
        var menu = _reactDom2.default.findDOMNode(_this3.refs.menu);
        var maxHeight = (_this3.props.dropdwonMaxRows || 8) - 1;
        var scrollHeight = index > maxHeight ? (index - maxHeight) * _this3.props.scrollHeight : 0;

        menu.scrollTop = scrollHeight;
    };

    this.setOpenState = function (visible) {
        _this3.setState({
            open: visible
        });
    };

    this.setActiveState = function (index) {
        _this3.setState({
            activeKey: String(index)
        });

        _this3.scrollTo(index);
    };

    this.onKeyDown = function (event) {
        var props = _this3.props;
        if (props.disabled) {
            return;
        }
        // console.log(props.type,props.type == "textarea")
        var keyCode = event.keyCode;
        if (_this3.state.open && !_this3.getInputDOMNode()) {
            _this3.onInputKeyDown(event);
        } else if (keyCode === _KeyCode2.default.ENTER || keyCode === _KeyCode2.default.DOWN) {
            //如果是textarea 模式就不支持 向下键和enter键 弹出下拉框
            props.type != "textarea" && _this3.setOpenState(true);
        }
    };

    this.getInputDOMNode = function () {
        return _this3.inputInstance;
    };

    this.onInputKeyDown = function (event) {
        var props = _this3.props;
        if (props.disabled) {
            return;
        }
        var state = _this3.state;
        var keyCode = event.keyCode;

        if (keyCode === _KeyCode2.default.DOWN || keyCode === _KeyCode2.default.UP) {
            if (!state.open && keyCode === _KeyCode2.default.DOWN) {
                _this3.openIfHasChildren();
                event.preventDefault();
                event.stopPropagation();
                return;
            } else {
                var _length = _this3.props.dataBody.length - 1;
                var currentKey = +_this3.state.activeKey;

                if (keyCode === _KeyCode2.default.DOWN) {
                    if (currentKey == _length) {
                        currentKey = 0;
                    } else {
                        currentKey += 1;
                    }
                } else {
                    if (currentKey == 0) {
                        currentKey = _length;
                    } else {
                        currentKey -= 1;
                    }
                }

                _this3.setActiveState(currentKey);
            }
        } else if (keyCode === _KeyCode2.default.ESC) {
            if (state.open) {
                _this3.setOpenState(false);
                event.preventDefault();
                event.stopPropagation();
            }
            return;
        } else if (keyCode === _KeyCode2.default.ENTER) {
            var _key = _this3.props.selectKey;
            var _obj = _this3.props.dataBody;
            var _currentKey = _this3.state.activeKey;
            _this3.setState({
                open: false,
                selectKeys: [String(_currentKey)]
            }, function () {
                return _this3.onSearch();
            });
            _this3.props.onChange && _this3.props.onChange(_obj[_currentKey][_key]);
            _this3.props.onSelect && _this3.props.onSelect(_obj[_key]);
            event.preventDefault();
            event.stopPropagation();
        }
    };

    this.openIfHasChildren = function () {
        var props = _this3.props;
        if (_react2.default.Children.count(props.children) || isSingleMode(props)) {
            _this3.setOpenState(true);
        }
    };

    this.handleChange = function (e) {
        _this3.props.onChange && _this3.props.onChange(e.target.value);
        _this3.props.dataBody && _this3.props.dataBody.length > 0 && _this3.setOpenState(true);
        _this3.setState({
            selectKeys: ['-1']
        }, function () {
            return _this3.onSearch();
        });
    };

    this.onSearch = function (e) {
        var onSearch = _this3.props.onSearch;
        var _key = _this3.state.selectKeys[0];
        var _obj = _this3.props.dataBody && _this3.props.dataBody[_key];
        //如果没有命中选项，则返回空对象
        !_obj && (_obj = {});
        onSearch && onSearch(_this3.refs.input.props.value, _obj);
    };

    this.onMenuSelect = function (value) {
        var _key = _this3.props.selectKey;
        var _obj = _this3.props.dataBody[value.key];
        var currentKey = _obj[_key];
        _this3.setState({
            open: false,
            selectKeys: [String(value.key)]
        }, function () {
            return _this3.onSearch();
        });
        _this3.setActiveState(value.key);
        _this3.props.onChange && _this3.props.onChange(currentKey);
        _this3.props.onSelect && _this3.props.onSelect(_obj);
    };

    this.handleBlur = function (propBlur) {
        var _value = _this3.refs.input.props.value;

        if (_this3.state.canMenuHide) {
            _this3.setOpenState(false);
            // 调用外部的失焦事件
            propBlur && propBlur();
            // 失焦的时候如果input 中被back 清掉了值，则把select
            !_value && _this3.setState({
                selectKeys: ['-1']
            });
        }
    };

    this.handleClick = function (e) {
        var isDisabled = _this3.props.disabled;
        if (!isDisabled) {
            _this3.props.onChange && _this3.props.onChange(e.target.value);
            _this3.setOpenState(true);
        }
    };

    this.handleMenuMouseEnter = function () {
        _this3.setState({
            canMenuHide: false
        });
    };

    this.handleMenuMouseLeave = function () {
        _this3.setState({
            canMenuHide: true
        });
        var input = _reactDom2.default.findDOMNode(_this3.refs.input).children[0];
        input.focus();
    };
};

exports.default = MultiColSelect;
module.exports = exports['default'];