'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

require('./styles/');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Panel(_ref) {
    var _classnames;

    var transparent = _ref.transparent,
        small = _ref.small,
        large = _ref.large,
        gray = _ref.gray,
        fnInline = _ref.fnInline,
        miniTitle = _ref.miniTitle,
        line = _ref.line,
        style = _ref.style,
        bodyStyle = _ref.bodyStyle,
        noMargin = _ref.noMargin,
        noHeaderBorder = _ref.noHeaderBorder,
        noPadding = _ref.noPadding,
        title = _ref.title,
        children = _ref.children,
        props = (0, _objectWithoutProperties3.default)(_ref, ['transparent', 'small', 'large', 'gray', 'fnInline', 'miniTitle', 'line', 'style', 'bodyStyle', 'noMargin', 'noHeaderBorder', 'noPadding', 'title', 'children']);

    var prifix = 'panel';
    var panelClass = (0, _classnames4.default)(prifix, (_classnames = {}, (0, _defineProperty3.default)(_classnames, prifix + "--transparent", transparent), (0, _defineProperty3.default)(_classnames, prifix + "--no-header-bd", noHeaderBorder), (0, _defineProperty3.default)(_classnames, prifix + "--no-padding", noPadding), (0, _defineProperty3.default)(_classnames, prifix + "--no-margin", noMargin), (0, _defineProperty3.default)(_classnames, prifix + "--mini-title", miniTitle), (0, _defineProperty3.default)(_classnames, prifix + "--line", line), (0, _defineProperty3.default)(_classnames, prifix + "--gray", gray), (0, _defineProperty3.default)(_classnames, prifix + "--small", small), (0, _defineProperty3.default)(_classnames, prifix + "--large", large), _classnames));

    var fnClass = (0, _classnames4.default)('panel__fn', (0, _defineProperty3.default)({}, 'panel__fn--inline', fnInline));

    return _react2.default.createElement(
        'div',
        { className: panelClass, style: style },
        title && _react2.default.createElement(
            'div',
            { className: 'panel__header' },
            _react2.default.createElement(
                'div',
                { className: 'panel__title' },
                title
            ),
            props.fn && _react2.default.createElement(
                'div',
                { className: fnClass },
                props.fn
            )
        ),
        _react2.default.createElement(
            'div',
            { className: 'panel__body', style: bodyStyle },
            children
        )
    );
}
//style
exports.default = Panel;
module.exports = exports['default'];