'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = replaceWrapper;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _replaceFunc = require('../util/replaceFunc');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var processData = function processData(value, _ref) {
	var needReplace = _ref.needReplace,
	    needUppercase = _ref.needUppercase,
	    needTransform = _ref.needTransform;

	if (!!value && typeof value === 'string') {
		if (needTransform) {
			value = (0, _replaceFunc.transformFullToHalf)(value);
		}
		if (needReplace) {
			value = (0, _replaceFunc.replaceInvisibleCharacter)(value);
		}
		if (needUppercase) {
			value = value.toUpperCase();
		}
	}
	return value;
};

var ReplaceWrappedComponent = function (_React$Component) {
	(0, _inherits3.default)(ReplaceWrappedComponent, _React$Component);

	function ReplaceWrappedComponent(props) {
		(0, _classCallCheck3.default)(this, ReplaceWrappedComponent);

		var _this = (0, _possibleConstructorReturn3.default)(this, (ReplaceWrappedComponent.__proto__ || (0, _getPrototypeOf2.default)(ReplaceWrappedComponent)).call(this, props));

		_this.onChange = function () {
			var _this$props2;

			for (var _len = arguments.length, rest = Array(_len), _key = 0; _key < _len; _key++) {
				rest[_key] = arguments[_key];
			}

			var _this$props$options = _this.props.options,
			    _this$props$options$n = _this$props$options.needReplace,
			    needReplace = _this$props$options$n === undefined ? true : _this$props$options$n,
			    _this$props$options$n2 = _this$props$options.needUppercase,
			    needUppercase = _this$props$options$n2 === undefined ? true : _this$props$options$n2,
			    _this$props$options$n3 = _this$props$options.needTransform,
			    needTransform = _this$props$options$n3 === undefined ? true : _this$props$options$n3,
			    _this$props$options$v = _this$props$options.valueKeyFromEvent,
			    valueKeyFromEvent = _this$props$options$v === undefined ? 'target.value' : _this$props$options$v;

			if (_this.isOnCompositionStart) {
				var _this$props;

				_lodash2.default.set(rest[0], 'type', 'composition');
				_this.props && _this.props.onChange && (_this$props = _this.props).onChange.apply(_this$props, rest);
				return;
			}
			var e = rest[0];
			var value = _lodash2.default.result(e, valueKeyFromEvent, '');
			if (valueKeyFromEvent === 'toString') {
				value = e;
			}
			var resultValue = value;
			if (!_this.isOnCompositionStart) {
				resultValue = processData(value, { needReplace: needReplace, needUppercase: needUppercase, needTransform: needTransform });
			}
			if (valueKeyFromEvent === 'toString') {
				e = resultValue;
			} else {
				_lodash2.default.set(e, valueKeyFromEvent, resultValue);
			}
			rest[0] = e;
			_lodash2.default.set(rest[0], 'type', 'change');
			_lodash2.default.set(rest[0], 'mode', 'replaceWrapper');
			_this.props && _this.props.onChange && (_this$props2 = _this.props).onChange.apply(_this$props2, rest);
		};

		_this.onCompositionStart = function (e) {
			_this.isOnCompositionStart = true;
		};

		_this.onCompositionEnd = function (e) {
			var _this$props$options$v2 = _this.props.options.valueKeyFromEvent,
			    valueKeyFromEvent = _this$props$options$v2 === undefined ? 'target.value' : _this$props$options$v2;

			_this.isOnCompositionStart = false;
			var value = e.currentTarget.value;
			var event = {};
			if (valueKeyFromEvent === 'toString') {
				event = value;
			} else {
				_lodash2.default.set(event, valueKeyFromEvent, value);
			}
			_this.onChange(event);
		};

		_this.isOnCompositionStart = false;
		return _this;
	}

	(0, _createClass3.default)(ReplaceWrappedComponent, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    ReactElement = _props.ReactElement,
			    options = _props.options,
			    props = (0, _objectWithoutProperties3.default)(_props, ['ReactElement', 'options']);

			return _react2.default.cloneElement(ReactElement, (0, _extends3.default)({}, props, { onCompositionStart: this.onCompositionStart, onChange: this.onChange, onCompositionEnd: this.onCompositionEnd }), null);
		}
	}]);
	return ReplaceWrappedComponent;
}(_react2.default.Component);

function replaceWrapper(ReactElement) {
	var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	return _react2.default.createElement(ReplaceWrappedComponent, (0, _extends3.default)({ ReactElement: ReactElement, options: options }, ReactElement.props));
}
module.exports = exports['default'];