'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style2 = require('../../antd/select/style');

var _select = require('../../antd/select');

var _select2 = _interopRequireDefault(_select);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('./styles/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Option = _select2.default.Option;

//props selectKey 指定一个key的值填入input中

var RichSelect = function (_Component) {
    (0, _inherits3.default)(RichSelect, _Component);

    function RichSelect(props) {
        (0, _classCallCheck3.default)(this, RichSelect);

        var _this = (0, _possibleConstructorReturn3.default)(this, (RichSelect.__proto__ || (0, _getPrototypeOf2.default)(RichSelect)).call(this, props));

        _this.handleSelect = function (value, option) {
            var _this$props = _this.props,
                dataBody = _this$props.dataBody,
                selectKey = _this$props.selectKey;

            var index = option.props.index;
            var obj = dataBody[index - 1];
            if (obj) {
                _this.props.onSelect && _this.props.onSelect(obj[selectKey], option, obj);
            }
        };

        _this.onChange = function (value) {
            if (!value) {
                try {
                    _this.props.onSelect && _this.props.onSelect('', {}, {});
                } catch (error) {}
            }
            _this.props.onChange && _this.props.onChange(value);
        };

        _this.getInputElement = function () {
            if (_this.props.getInputElement) {
                return _this.props.getInputElement();
            } else {
                return _react2.default.createElement('input', {
                    id: _this.props.id,
                    onCompositionStart: _this.props.onCompositionStart,
                    onCompositionEnd: _this.props.onCompositionEnd,
                    onCompositionEndCapture: _this.props.onCompositionEndCapture,
                    onCompositionUpdate: _this.props.onCompositionUpdate,
                    onCompositionStartCapture: _this.props.onCompositionStartCapture,
                    onCompositionUpdateCapture: _this.props.onCompositionUpdateCapture
                });
            }
        };

        return _this;
    }

    (0, _createClass3.default)(RichSelect, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                dataHeader = _props.dataHeader,
                dataBody = _props.dataBody,
                selectKey = _props.selectKey,
                _props$notFoundConten = _props.notFoundContent,
                notFoundContent = _props$notFoundConten === undefined ? "not found" : _props$notFoundConten,
                _props$dropdownMatchS = _props.dropdownMatchSelectWidth,
                dropdownMatchSelectWidth = _props$dropdownMatchS === undefined ? false : _props$dropdownMatchS,
                onChange = _props.onChange,
                props = (0, _objectWithoutProperties3.default)(_props, ['dataHeader', 'dataBody', 'selectKey', 'notFoundContent', 'dropdownMatchSelectWidth', 'onChange']);

            var hasDataBody = dataBody && dataBody.length > 0;
            var dropdownHeadData = dataHeader,
                dropdownBodyData = hasDataBody ? dataBody : notFoundContent;
            //console.log(dataHeader)
            // 拼接下拉框header部分结构
            var dropdownHeadElement = dropdownHeadData ? _react2.default.createElement(
                Option,
                { key: 'title', disabled: true },
                dropdownHeadData.map(function (val) {
                    return _react2.default.createElement(
                        'p',
                        {
                            key: val.dataIndex },
                        val.title
                    );
                })
            ) : '';
            var dropdownBodyElement = !hasDataBody ? _react2.default.createElement(
                Option,
                { key: 'no-data', className: 'no-data', disabled: true },
                _react2.default.createElement(
                    'p',
                    { colSpan: '2' },
                    dropdownBodyData
                ),
                _react2.default.createElement('p', null)
            ) : createBodyElement();

            //下拉框body部分
            function createBodyElement() {
                var isArray = dropdownBodyData instanceof Array;
                if (!isArray) {
                    throw new TypeError('RichSelect 组件的 dataBody 只接受 "Array" 格式的数据');
                }

                var convertDuplicateToUnique = function convertDuplicateToUnique(array, key) {
                    var temp = {};
                    array.forEach(function (item) {
                        temp[item[key]] = pushToList(temp[item[key]], item);
                        var length = temp[item[key]].length;
                        if (length > 1) {
                            item[key] = temp[item[key]][length - 2][key] + ' ';
                        }
                    });
                    return array;
                };

                var pushToList = function pushToList(item, value) {
                    if (item === undefined) {
                        item = [];
                    }
                    item.push(value);
                    return item;
                };

                dropdownBodyData = convertDuplicateToUnique(dropdownBodyData, selectKey);

                return dropdownBodyData.map(function (val, index) {
                    // TODO unique key问题
                    var parentVal = val;
                    var _item = dropdownHeadData.map(function (val, i) {
                        return _react2.default.createElement(
                            'p',
                            { key: val.dataIndex, title: parentVal[val.dataIndex] },
                            parentVal[val.dataIndex]
                        );
                    });
                    return _react2.default.createElement(
                        Option,
                        { key: index, value: val[selectKey] },
                        _item
                    ); //这里的key可以当value使用，不用再定义value
                });
            }

            return _react2.default.createElement(
                _select2.default,
                (0, _extends3.default)({ ref: 'input' }, props, { dropdownMatchSelectWidth: dropdownMatchSelectWidth, onChange: this.onChange,
                    optionLabelProp: "value", dropdownClassName: 'rich-select ' + this.props.id + '-dzg-rich-select',
                    onSelect: this.handleSelect, getInputElement: this.getInputElement }),
                dropdownHeadElement,
                dropdownBodyElement
            );
        }
    }]);
    return RichSelect;
}(_react.Component);

RichSelect.propTypes = {
    dataBody: _react2.default.PropTypes.array,
    dataHead: _react2.default.PropTypes.object,
    dropdwonMaxRows: _react2.default.PropTypes.number
};
RichSelect.defaultProps = {
    selectKey: "value",
    disabled: false,
    scrollHeight: 32
};
exports.default = RichSelect;
module.exports = exports['default'];