'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _style2 = require('../../antd/transfer/style');

var _transfer = require('../../antd/transfer');

var _transfer2 = _interopRequireDefault(_transfer);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.isRenderResultPlainObject = isRenderResultPlainObject;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcAnimate = require('rc-animate');

var _rcAnimate2 = _interopRequireDefault(_rcAnimate);

var _search = require('../../antd/transfer/search');

var _search2 = _interopRequireDefault(_search);

var _item = require('../../antd/transfer/item');

var _item2 = _interopRequireDefault(_item);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isRenderResultPlainObject(result) {
    return result && !_react2.default.isValidElement(result) && Object.prototype.toString.call(result) === '[object Object]';
}

//@see https://github.com/ant-design/ant-design/blob/1.x-stable/components/transfer/list.jsx#L206

var CustomTransfer = function (_Component) {
    (0, _inherits3.default)(CustomTransfer, _Component);

    function CustomTransfer(props) {
        (0, _classCallCheck3.default)(this, CustomTransfer);

        var _this = (0, _possibleConstructorReturn3.default)(this, (CustomTransfer.__proto__ || (0, _getPrototypeOf2.default)(CustomTransfer)).call(this, props));

        _this.renderTransferBody = function (_ref) {
            var dataSource = _ref.dataSource,
                render = _ref.render,
                showSearch = _ref.showSearch,
                prefixCls = _ref.prefixCls,
                filter = _ref.filter,
                filterOption = _ref.filterOption,
                handleFilter = _ref.handleFilter,
                handleClear = _ref.handleClear,
                handleSelect = _ref.handleSelect,
                checkedKeys = _ref.checkedKeys,
                searchPlaceholder = _ref.searchPlaceholder,
                notFoundContent = _ref.notFoundContent;
            var onSelectChange = _this.props.onSelectChange;


            function matchFilter(filterText, item, text) {
                if (filterOption) {
                    return filterOption(filterText, item);
                }
                return text.indexOf(filterText) >= 0;
            }

            function innerHandleSelect(selectedItem) {
                var result = checkedKeys.some(function (key) {
                    return key === selectedItem.key;
                });
                handleSelect(selectedItem, !result);
                onSelectChange && onSelectChange(selectedItem, !result);
            }

            var showItems = dataSource.filter(function (item) {
                return !!item;
            }).map(function (item) {
                var renderResult = render(item);
                var renderedText = void 0;
                var renderedEl = void 0;

                if (isRenderResultPlainObject(renderResult)) {
                    renderedText = renderResult.value;
                    renderedEl = renderResult.label;
                } else {
                    renderedText = renderResult;
                    renderedEl = renderResult;
                }

                if (filter && filter.trim() && !matchFilter(filter, item, renderedText)) {
                    return null;
                }
                var checked = checkedKeys.indexOf(item.key) >= 0;
                var lazy = { "height": 20, "offset": 20 };
                return _react2.default.createElement(_item2.default, {
                    key: item.key,
                    item: item,
                    lazy: lazy,
                    renderedText: renderedText,
                    renderedEl: renderedEl,
                    checked: checked,
                    prefixCls: prefixCls,
                    onClick: innerHandleSelect
                });
            });

            return _react2.default.createElement(
                'div',
                { className: showSearch ? prefixCls + '-body ' + prefixCls + '-body-with-search' : prefixCls + '-body' },
                showSearch ? _react2.default.createElement(
                    'div',
                    { className: prefixCls + '-body-search-wrapper' },
                    _react2.default.createElement(_search2.default, { prefixCls: prefixCls + '-search',
                        onChange: handleFilter,
                        handleClear: handleClear,
                        placeholder: searchPlaceholder || '请输入搜索内容',
                        value: filter
                    })
                ) : null,
                _react2.default.createElement(
                    _rcAnimate2.default,
                    { component: 'ul',
                        className: prefixCls + '-content',
                        transitionName: _this.state.mounted ? prefixCls + '-highlight' : '',
                        transitionLeave: false
                    },
                    showItems.length > 0 ? showItems : _react2.default.createElement(
                        'div',
                        { className: prefixCls + '-body-not-found' },
                        notFoundContent || '列表为空'
                    )
                )
            );
        };

        _this.state = {
            mounted: false
        };
        return _this;
    }

    (0, _createClass3.default)(CustomTransfer, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            this.timer = setTimeout(function () {
                _this2.setState({
                    mounted: true
                });
            }, 0);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            clearTimeout(this.timer);
        }
    }, {
        key: 'render',
        value: function render() {
            var body = this.renderTransferBody;
            return _react2.default.createElement(_transfer2.default, (0, _extends3.default)({}, this.props, { body: body }));
        }
    }]);
    return CustomTransfer;
}(_react.Component);

exports.default = CustomTransfer;