'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _style4 = require('../../antd/row/style');

var _row = require('../../antd/row');

var _row2 = _interopRequireDefault(_row);

var _style5 = require('../../antd/col/style');

var _col = require('../../antd/col');

var _col2 = _interopRequireDefault(_col);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _style6 = require('../../antd/olym-table/style');

var _olymTable = require('../../antd/olym-table');

var _olymTable2 = _interopRequireDefault(_olymTable);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _CustomColumnsModal = require('./CustomColumnsModal');

var _CustomColumnsModal2 = _interopRequireDefault(_CustomColumnsModal);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

var _api = require('./api');

var _api2 = _interopRequireDefault(_api);

var _message = require('../../antd/message');

var _message2 = _interopRequireDefault(_message);

var _resizeObserver = require('resize-observer');

require('./style.css');

require('../styles/common.less');

require('../../antd/message/style');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Table = function (_Component) {
	(0, _inherits3.default)(Table, _Component);

	function Table(props) {
		(0, _classCallCheck3.default)(this, Table);

		var _this = (0, _possibleConstructorReturn3.default)(this, (Table.__proto__ || (0, _getPrototypeOf2.default)(Table)).call(this, props));

		_initialiseProps.call(_this);

		var pagination = props.pagination;
		_this.state = {
			timeId: new Date().valueOf(),
			scrollHeight: 300
		};
		if (pagination && _this.isCustomizeColumnTable()) {
			_this.state.pagination = _this.updatePaginationWithPageSize(_lodash2.default.result(pagination, 'pageSize'), _lodash2.default.result(pagination, 'current'), _lodash2.default.result(pagination, 'total'));
		}
		return _this;
	}

	(0, _createClass3.default)(Table, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			if (this.observer) {
				this.observer.disconnect();
			}
			this.isMount = false;
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			var paginationParam = ['pageSize', 'current', 'total'];
			if (this.isCustomizeColumnTable() && !_lodash2.default.isEqual(_lodash2.default.pick(this.props.pagination, paginationParam), _lodash2.default.pick(nextProps.pagination, paginationParam))) {
				var pagination = nextProps.pagination;
				this.setState({
					pagination: this.updatePaginationWithPageSize(_lodash2.default.result(pagination, 'pageSize'), _lodash2.default.result(pagination, 'current'), _lodash2.default.result(pagination, 'total'))
				});
			}
		}

		//设置可拖拽控制宽度

	}, {
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {
			if (_lodash2.default.isEqual(nextProps, this.props) && _lodash2.default.isEqual(nextState, this.state)) {
				return false;
			} else {
				return true;
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    customCtns = _props.customCtns,
			    title = _props.title;
			var timeId = this.state.timeId;

			var customColumns = this.getCustomColumns();
			//把处理完的数据组合成新的props
			var props = (0, _extends3.default)({}, _lodash2.default.pick(this.props, _constants2.default.antDTableKeys), {
				onChange: this.onPaginationChange,
				dataSource: this.getDataSource(),
				columns: this.getUserDefinedColumns(customColumns),
				pagination: this.isCustomizeColumnTable() ? this.state.pagination : this.props.pagination
			});
			if (title || customCtns || customColumns && customColumns.length > 0) {
				props.title = this.getTableTitle;
			}

			//scroll
			if (props.scroll && props.scroll.y) {
				var className = props.className || '';
				className += ' ant-table-scroll-y';
				props.className = className;
			}
			//动态height
			if (this.props.observeId) {
				props.scroll = (0, _extends3.default)({}, props.scroll, {
					y: this.state.scrollHeight
				});
			}

			return _react2.default.createElement(
				'div',
				{ id: timeId },
				_react2.default.createElement(_olymTable2.default, props)
			);
		}
	}]);
	return Table;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.componentDidMount = function () {
		if (_this2.isCustomizeColumnTable()) {
			_this2.initPagination();
		}
		//设置拖拽
		_utils2.default.setDraggableColumns(_this2);
		_this2.isMount = true;
		_this2.observeHeight();
	};

	this.observeHeight = function () {
		if (!_this2.props.observeId) {
			return;
		}
		_this2.observer = new _resizeObserver.ResizeObserver(function (entries) {
			if (_this2.isMount) {
				var entry = entries[0];
				if (entry) {
					var height = entry.contentRect.height;
					if (height !== _this2.observeHeight) {
						_this2.observeHeight = height;
						var scrollHeight = document.getElementsByClassName("ant-table-body")[0].offsetHeight + (window.innerHeight - document.getElementById('app').offsetHeight) - 10;
						_this2.setState({ scrollHeight: scrollHeight });
					}
				}
			}
		});
		_this2.observer.observe(document.getElementById(_this2.props.observeId));
	};

	this.initPagination = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
		var _ref2, total, current;

		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.next = 2;
						return _this2.fetchCustomColumns();

					case 2:
						_context.next = 4;
						return _this2.props.fetchDataSource(_this2.state.pagination);

					case 4:
						_ref2 = _context.sent;
						total = _ref2.total;
						current = _ref2.current;

						_this2.setState({
							pagination: (0, _extends3.default)({}, _this2.state.pagination, {
								total: total,
								current: current
							})
						});

					case 8:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, _this2);
	}));

	this.isCustomizeColumnTable = function () {
		return _this2.props.customVo && _this2.props.fetchDataSource && _this2.props.getColumns;
	};

	this.onShowSizeChange = function () {
		var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(currentPage, size) {
			var _ref4, total, current;

			return _regenerator2.default.wrap(function _callee2$(_context2) {
				while (1) {
					switch (_context2.prev = _context2.next) {
						case 0:
							_context2.next = 2;
							return _api2.default.saveCustomPageSize(_this2.props.customVo, size);

						case 2:
							_context2.next = 4;
							return _this2.props.fetchDataSource(_this2.updatePaginationWithPageSize(size));

						case 4:
							_ref4 = _context2.sent;
							total = _ref4.total;
							current = _ref4.current;

							_this2.setState({
								pagination: (0, _extends3.default)({}, _this2.state.pagination, {
									total: total,
									current: current
								})
							});

						case 8:
						case 'end':
							return _context2.stop();
					}
				}
			}, _callee2, _this2);
		}));

		return function (_x, _x2) {
			return _ref3.apply(this, arguments);
		};
	}();

	this.onPaginationChange = function () {
		var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(pagination, filters, sorter) {
			var _ref6, total, current;

			return _regenerator2.default.wrap(function _callee3$(_context3) {
				while (1) {
					switch (_context3.prev = _context3.next) {
						case 0:
							_context3.next = 2;
							return _this2.props.fetchDataSource(pagination, filters, sorter);

						case 2:
							_ref6 = _context3.sent;
							total = _ref6.total;
							current = _ref6.current;

							_this2.setState({
								pagination: (0, _extends3.default)({}, _this2.state.pagination, {
									total: total,
									current: current
								})
							});

						case 6:
						case 'end':
							return _context3.stop();
					}
				}
			}, _callee3, _this2);
		}));

		return function (_x3, _x4, _x5) {
			return _ref5.apply(this, arguments);
		};
	}();

	this.updatePaginationWithPageSize = function (pageSize) {
		var current = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
		var total = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

		var pagination = {
			pageSize: pageSize,
			current: current,
			showTotal: function showTotal(total) {
				return '\u5171' + total + '\u6761\uFF0C\u6BCF\u9875' + pageSize + '\u6761';
			},
			showQuickJumper: true,
			showSizeChanger: true,
			pageSizeOptions: ['10', '15', '30', '50', '100'],
			onShowSizeChange: _this2.onShowSizeChange,
			total: total
		};
		return pagination;
	};

	this.fetchCustomColumns = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
		var result, _props$getColumns, columns, customColumns, tableWidth;

		return _regenerator2.default.wrap(function _callee4$(_context4) {
			while (1) {
				switch (_context4.prev = _context4.next) {
					case 0:
						_context4.next = 2;
						return _api2.default.getCustomLine(_this2.props.customVo);

					case 2:
						result = _context4.sent;
						_props$getColumns = _this2.props.getColumns(result), columns = _props$getColumns.columns, customColumns = _props$getColumns.customColumns, tableWidth = _props$getColumns.tableWidth;

						_this2.state.pagination = _this2.updatePaginationWithPageSize(_lodash2.default.result(result, 'userSet.pageSize', 15));
						_this2.setState({
							pagination: _this2.state.pagination,
							columns: columns,
							tableWidth: tableWidth,
							customColumns: customColumns
						});

					case 6:
					case 'end':
						return _context4.stop();
				}
			}
		}, _callee4, _this2);
	}));

	this.saveCustomColumns = function () {
		var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(selectedColumns) {
			var customVo, comPortletSetVo, columns, _ref9, total, current;

			return _regenerator2.default.wrap(function _callee5$(_context5) {
				while (1) {
					switch (_context5.prev = _context5.next) {
						case 0:
							customVo = _this2.props.customVo;
							comPortletSetVo = (0, _extends3.default)({}, customVo);
							columns = [];

							selectedColumns && selectedColumns.columnKeys.forEach(function (obj) {
								if (obj.dataIndex !== 'cao_zuo_id') {
									columns.push({
										elementName: obj.dataIndex
									});
								}
							});
							comPortletSetVo.columns = (0, _stringify2.default)(columns);
							_context5.next = 7;
							return _api2.default.saveCustomLine((0, _extends3.default)({}, comPortletSetVo, { pageSize: _this2.state.pagination.pageSize }));

						case 7:
							_message2.default.success('自定义列保存成功！');
							_this2.fetchCustomColumns();
							_context5.next = 11;
							return _this2.props.fetchDataSource(_this2.state.pagination);

						case 11:
							_ref9 = _context5.sent;
							total = _ref9.total;
							current = _ref9.current;

							_this2.setState({
								pagination: (0, _extends3.default)({}, _this2.state.pagination, {
									total: total,
									current: current
								})
							});

						case 15:
						case 'end':
							return _context5.stop();
					}
				}
			}, _callee5, _this2);
		}));

		return function (_x8) {
			return _ref8.apply(this, arguments);
		};
	}();

	this.componentDidUpdate = function () {
		_utils2.default.setDraggableColumns(_this2, _this2.saveCustomizeColWidth);
	};

	this.saveCustomizeColWidth = function ($cols) {
		//是否显示序号 是否显示选择框
		var customVo = _this2.props.customVo;

		var columns = _this2.getAllVisibleColumns();
		var colWidths = Array.prototype.map.call($cols, function (e) {
			return e.style.width;
		});
		if (_lodash2.default.isEmpty(customVo) || (typeof customVo === 'undefined' ? 'undefined' : (0, _typeof3.default)(customVo)) !== 'object') {
			return;
		}
		var name = _this2.getCustomizeColWidthKey();
		var columnsWidth = {};
		columns.forEach(function (o, i) {
			columnsWidth[o.dataIndex] = colWidths[i];
		});
		if (window.localStorage) {
			window.localStorage.setItem(name, (0, _stringify2.default)(columnsWidth));
		}
	};

	this.getCustomizeColWidthKey = function () {
		var customVo = _this2.props.customVo;

		if (_lodash2.default.isEmpty(customVo) || (typeof customVo === 'undefined' ? 'undefined' : (0, _typeof3.default)(customVo)) !== 'object') {
			return '';
		}
		var appCode = customVo.appCode,
		    modelId = customVo.modelId,
		    pageName = customVo.pageName,
		    portletName = customVo.portletName;

		var name = 'CUSTOMIZE_COL_WIDTH-' + appCode + '-' + modelId + '-' + pageName + '-' + portletName;
		return name;
	};

	this.getAllVisibleColumns = function () {
		//是否显示序号 是否显示选择框
		var _props2 = _this2.props,
		    rowSelection = _props2.rowSelection,
		    columns = _props2.columns;

		var customColumns = _this2.getCustomColumns();
		columns = [].concat((0, _toConsumableArray3.default)(_this2.getUserDefinedColumns(customColumns)));
		if (!_lodash2.default.isEmpty(rowSelection)) {
			columns.unshift({
				dataIndex: 'rowSelection'
			});
		}
		columns.sort(function (a, b) {
			return a.orderNo - b.orderNo;
		});
		return columns;
	};

	this.getUserDefineCol = function (columns, customColumns) {
		var colWidthsObject = {};
		if (window.localStorage) {
			var name = _this2.getCustomizeColWidthKey();
			colWidthsObject = JSON.parse(window.localStorage.getItem(name));
		}
		if (!customColumns || customColumns.length === 0) {
			return _lodash2.default.extend([], columns).map(function (item) {
				var dataIndex = item.dataIndex;
				if (!_lodash2.default.isEmpty(colWidthsObject) && dataIndex in colWidthsObject) {
					item.width = colWidthsObject[dataIndex];
				}
				return item;
			});
		}
		var userDefineColumns = [];
		var customColumnsMap = {};
		customColumns.map(function (col) {
			customColumnsMap[col.dataIndex] = col;
		});
		var extraColumns = [];
		columns.forEach(function (obj) {
			var dataIndex = obj.dataIndex;
			if (!_lodash2.default.isEmpty(colWidthsObject) && dataIndex in colWidthsObject) {
				obj.width = colWidthsObject[dataIndex];
			}
			if (!obj.key) {
				obj.key = obj.dataIndex;
			}
			if (customColumnsMap[dataIndex]) {
				var customCol = customColumnsMap[dataIndex];
				if (customCol.orderNo && customCol.orderNo > -1) {
					obj.orderNo = customColumnsMap[dataIndex].orderNo;
					userDefineColumns.push(obj);
				}
			} else {
				extraColumns.push(obj);
			}
		});
		userDefineColumns = userDefineColumns.concat(extraColumns);
		userDefineColumns.sort(function (a, b) {
			return a.orderNo - b.orderNo;
		});
		return userDefineColumns;
	};

	this.getDataSource = function () {
		var _props3 = _this2.props,
		    showSeq = _props3.showSeq,
		    dataSource = _props3.dataSource;

		if (showSeq) {
			return dataSource.map(function (item, index) {
				return (0, _extends3.default)({}, item, {
					DZG_SEQ_COLUMN: index + 1
				});
			});
		}
		return dataSource;
	};

	this.getCustomColumns = function () {
		var customColumns = _this2.props.customColumns || _this2.state.customColumns;
		var _customColumns = [];
		customColumns && customColumns.map(function (col) {
			var orderNo = col.orderNo,
			    dataIndex = col.dataIndex,
			    title = col.title;

			_customColumns.push({ orderNo: orderNo, dataIndex: dataIndex, title: title });
		});
		_customColumns.sort(function (a, b) {
			return a.orderNo - b.orderNo;
		});
		return _customColumns;
	};

	this.getUserDefinedColumns = function (customColumns) {
		var _props4 = _this2.props,
		    showSeq = _props4.showSeq,
		    dataSource = _props4.dataSource;

		var columns = _this2.props.columns || _this2.state.columns;
		var userDefineColumns = _this2.getUserDefineCol(columns, customColumns);
		var _dataSource = void 0;

		if (showSeq) {
			//显示序号
			_dataSource = [];
			dataSource.forEach(function (data, index) {
				_dataSource.push((0, _extends3.default)({
					DZG_SEQ_COLUMN: index + 1
				}, data));
			});
			userDefineColumns.unshift({
				dataIndex: 'DZG_SEQ_COLUMN',
				key: 'DZG_SEQ_COLUMN',
				title: '序号',
				width: 50,
				render: function render(text, record, index) {
					return _react2.default.createElement(
						'div',
						{ key: 'DZG_SEQ_COLUMN_' + index, style: { display: 'flex', justifyContent: 'center' } },
						text
					);
				}
			});
		}
		return userDefineColumns;
	};

	this.getTableTitle = function () {
		var _props5 = _this2.props,
		    _props5$leftSpan = _props5.leftSpan,
		    leftSpan = _props5$leftSpan === undefined ? 6 : _props5$leftSpan,
		    _props5$rightSpan = _props5.rightSpan,
		    rightSpan = _props5$rightSpan === undefined ? 18 : _props5$rightSpan,
		    _props5$selectedRowKe = _props5.selectedRowKeysCount,
		    selectedRowKeysCount = _props5$selectedRowKe === undefined ? 0 : _props5$selectedRowKe,
		    title = _props5.title,
		    onCustomChange = _props5.onCustomChange,
		    customCtns = _props5.customCtns;

		var customColumns = _this2.getCustomColumns();
		var left = function left() {
			var leftChildren = [];
			if (title) {
				if (typeof title === 'string') {
					leftChildren.push(_react2.default.createElement(
						'b',
						{ key: 'table_title' },
						title
					));
				} else {
					leftChildren.push(title);
				}
			}
			if (customColumns && Array.isArray(customColumns) && customColumns.length > 0) {
				var buttonProps = {
					size: 'small',
					key: 'custom'
				};
				if (title) {
					buttonProps.className = 'ml8';
				}
				// 弹出框参数
				var modalOpts = {
					columnKeys: customColumns,
					onOk: _this2.props.onCustomChange || _this2.saveCustomColumns,
					customColumns: customColumns
				};
				leftChildren.push(_react2.default.createElement(_CustomColumnsModal2.default, (0, _extends3.default)({ key: 'custom_columns', buttonProps: buttonProps }, modalOpts)));
			}
			//选中条数
			if (!!selectedRowKeysCount) {
				leftChildren.push(_react2.default.createElement(
					'span',
					{ key: 'count' },
					'\xA0\xA0\u5DF2\u9009\u62E9',
					selectedRowKeysCount,
					'\u9879'
				));
			}
			if (leftChildren.length === 0) {
				return;
			}
			return _react2.default.createElement(
				'div',
				{ className: 'tal', key: 'leftarea' },
				leftChildren
			);
		};
		var right = function right() {
			var rightChildren = [];
			if (customCtns && Array.isArray(customCtns) && customCtns.length > 0) {
				customCtns.map(function (btn) {
					var props = btn.props,
					    others = (0, _objectWithoutProperties3.default)(btn, ['props']);

					var _btn = (0, _extends3.default)({
						props: (0, _extends3.default)({}, props, {
							className: 'custom_other_btn_right'
						})
					}, others);
					rightChildren.unshift(_btn);
				});
				return _react2.default.createElement(
					'div',
					{ className: 'tar', key: 'rightarea' },
					rightChildren
				);
			} else if (customCtns && typeof customCtns === 'function') {
				return _react2.default.createElement(
					'div',
					{ className: 'tar', key: 'rightarea' },
					customCtns()
				);
			}
		};
		return _react2.default.createElement(
			_row2.default,
			null,
			_react2.default.createElement(
				_col2.default,
				{ key: 'left', span: leftSpan },
				left()
			),
			_react2.default.createElement(
				_col2.default,
				{ key: 'right', span: rightSpan },
				right()
			)
		);
	};
};

exports.default = Table;


Table.propTypes = {
	columns: _propTypes2.default.array, // table列参数
	customColumns: _propTypes2.default.array,
	customVo: _propTypes2.default.shape({
		// 获取自定义列请求参数
		appCode: _propTypes2.default.string,
		modelId: _propTypes2.default.string,
		pageName: _propTypes2.default.string,
		portletName: _propTypes2.default.string
	}),
	staticColumns: _propTypes2.default.array, // 不可自定义的列
	fetchDataSource: _propTypes2.default.func };
module.exports = exports['default'];