'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  setDraggableColumns: function setDraggableColumns(currentTable, onDragEnd) {
    var columns = currentTable.getUserDefinedColumns(currentTable.getCustomColumns());

    var scroll = currentTable.props.scroll;
    var timeId = currentTable.state.timeId;

    var haveColumnFixed = false;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator3.default)(columns), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _i4 = _step.value;

        if (_i4.fixed) {
          haveColumnFixed = true;
          break;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    (0, _jquery2.default)('#' + timeId + ' th,td').css({
      position: 'relative'
    });
    for (var k = 0; k < (0, _jquery2.default)('#' + timeId + ' table').length; k++) {
      for (var i = 0; i < (0, _jquery2.default)('#' + timeId + ' table').eq(k).find('th').length; i++) {
        if ((0, _jquery2.default)('#' + timeId + ' table').eq(k).find('th').eq(i).find('.druagle-border').length !== 0) {
          continue;
        }
        (0, _jquery2.default)('#' + timeId + ' table').eq(k).find('th').eq(i).append('<div dataIndex=' + i + ' tableIndex=' + k + ' class="druagle-border" style="width:0;height:100%;border-right:2px solid transparent;cursor:e-resize;position:absolute;right:0;top:0"></div>');
      }
    }
    var isMoveStart = false;
    var oldX = 0;
    var oldWidth = 0;
    var oldTableWidth = 0;
    var selectIndex = 0;
    var tableIndex = 0;
    var tableThis = void 0;
    (0, _jquery2.default)('#' + timeId + ' th .druagle-border').on('mousedown', function () {
      isMoveStart = true;
      oldX = event.screenX;
      oldWidth = (0, _jquery2.default)('#' + timeId + ' table').eq((0, _jquery2.default)(this).attr('tableIndex')).find('th').eq((0, _jquery2.default)(this).attr('dataIndex')).width();
      selectIndex = (0, _jquery2.default)(this).attr('dataIndex');
      tableIndex = (0, _jquery2.default)(this).attr('tableIndex');
      oldTableWidth = (0, _jquery2.default)('#' + timeId + ' table').eq((0, _jquery2.default)(this).attr('tableIndex')).width();
      tableThis = (0, _jquery2.default)('#' + timeId + ' table').eq((0, _jquery2.default)(this).attr('tableIndex'));
      (0, _jquery2.default)('#' + timeId + ' col').css({
        minWidth: 50
      });
    });

    (0, _jquery2.default)('#' + timeId + ' table').on('mousemove', function () {
      if (isMoveStart && event.screenX - oldX + oldWidth > 50) {
        (0, _jquery2.default)('#' + timeId + ' .ant-table-fixed-left th').height(tableThis.find('th').height());
        (0, _jquery2.default)('#' + timeId + ' .ant-table-fixed-right th').height(tableThis.find('th').height());
        for (var _i = 0; _i < tableThis.find('tr').length; _i++) {
          (0, _jquery2.default)('#' + timeId + ' .ant-table-fixed-left tr').eq(_i).height(tableThis.find('tr').eq(_i).height());
          (0, _jquery2.default)('#' + timeId + ' .ant-table-fixed-right tr').eq(_i).height(tableThis.find('tr').eq(_i).height());
        }
        if (scroll && scroll.y && !haveColumnFixed) {
          for (var _i2 = 0; _i2 < (0, _jquery2.default)('#' + timeId + ' table').length; _i2++) {
            (0, _jquery2.default)('#' + timeId + ' table').eq(_i2).find('col').eq(selectIndex).width(event.screenX - oldX + oldWidth);
            (0, _jquery2.default)('#' + timeId + ' table').eq(_i2).width(oldTableWidth + event.screenX - oldX + oldWidth - oldWidth);
          }
        } else if (scroll && scroll.y && haveColumnFixed) {
          //暂设置为 fixed部分table不允许拖动。
          if (tableThis.parent().parent().attr('class') == 'ant-table-scroll') {
            for (var _i3 = 0; _i3 < tableThis.parent().parent().find('table').length; _i3++) {
              tableThis.parent().parent().find('table').eq(_i3).find('col').eq(selectIndex).width(event.screenX - oldX + oldWidth);
              tableThis.parent().parent().find('table').eq(_i3).width(oldTableWidth + event.screenX - oldX + oldWidth - oldWidth);
            }
          }
        } else {
          if (tableThis.parent().parent().attr('class') == 'ant-table-scroll') {
            (0, _jquery2.default)('#' + timeId + ' table').eq(tableIndex).find('col').eq(selectIndex).width(event.screenX - oldX + oldWidth);
            (0, _jquery2.default)('#' + timeId + ' table').eq(tableIndex).width(oldTableWidth + event.screenX - oldX + oldWidth - oldWidth);
          }
        }
      }
    });
    (0, _jquery2.default)('#' + timeId + ' table').on('mouseup', function () {
      var needSaveCustomizeColWidth = isMoveStart;
      isMoveStart = false;
      needSaveCustomizeColWidth && onDragEnd && onDragEnd((0, _jquery2.default)('#' + timeId + ' table').find('col'));
    });
    (0, _jquery2.default)('#' + timeId + ' table').on('mouseleave', function () {
      var needSaveCustomizeColWidth = isMoveStart;
      isMoveStart = false;
      needSaveCustomizeColWidth && onDragEnd && onDragEnd((0, _jquery2.default)('#' + timeId + ' table').find('col'));
    });
  }
};
module.exports = exports['default'];