'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _style3 = require('../../antd/text-area-select/style');

var _textAreaSelect = require('../../antd/text-area-select');

var _textAreaSelect2 = _interopRequireDefault(_textAreaSelect);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _style4 = require('../../antd/select/style');

var _select = require('../../antd/select');

var _select2 = _interopRequireDefault(_select);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('./styles/index');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _arrayUtils = require('../util/arrayUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Option = _select2.default.Option;

var TextAreaRichSelect = function (_Component) {
    (0, _inherits3.default)(TextAreaRichSelect, _Component);

    function TextAreaRichSelect(props) {
        (0, _classCallCheck3.default)(this, TextAreaRichSelect);

        var _this = (0, _possibleConstructorReturn3.default)(this, (TextAreaRichSelect.__proto__ || (0, _getPrototypeOf2.default)(TextAreaRichSelect)).call(this, props));

        _this.handleSelect = function (value, option) {
            var _this$props = _this.props,
                dataBody = _this$props.dataBody,
                selectKey = _this$props.selectKey;

            var index = option.props.index;
            var obj = dataBody[index - 1];
            if (obj) {
                _this.props.onSelect && _this.props.onSelect(obj[selectKey], option, obj);
            }
        };

        _this.getDropDownHeadElement = function () {
            var dataHeader = _this.props.dataHeader;
            if (dataHeader) {
                return _react2.default.createElement(
                    Option,
                    { key: 'title', disabled: true },
                    dataHeader.map(function (item) {
                        return _react2.default.createElement(
                            'p',
                            { key: item.dataIndex },
                            item.title
                        );
                    })
                );
            }
            return '';
        };

        _this.getDropDownBodyElement = function () {
            var dataBody = _this.props.dataBody;
            if (dataBody && dataBody.length > 0) {
                var selectKey = _this.props.selectKey;
                dataBody = (0, _arrayUtils.convertDuplicateToUnique)(dataBody, selectKey);
                return dataBody.map(function (item) {
                    var value = _this.props.dataHeader.map(function (item2) {
                        return _react2.default.createElement(
                            'p',
                            { key: item2.dataIndex },
                            item[item2.dataIndex]
                        );
                    });
                    return _react2.default.createElement(
                        Option,
                        { key: item[selectKey] },
                        value
                    );
                });
            } else {
                return _react2.default.createElement(
                    Option,
                    { key: 'no-data', className: 'no-data', disabled: true },
                    _react2.default.createElement(
                        'p',
                        { colSpan: '2' },
                        _this.props.notFoundContent
                    ),
                    _react2.default.createElement('p', null)
                );
            }
        };

        return _this;
    }

    (0, _createClass3.default)(TextAreaRichSelect, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                dataHeader = _props.dataHeader,
                dataBody = _props.dataBody,
                selectKey = _props.selectKey,
                notFoundContent = _props.notFoundContent,
                props = (0, _objectWithoutProperties3.default)(_props, ['dataHeader', 'dataBody', 'selectKey', 'notFoundContent']);

            return _react2.default.createElement(
                _textAreaSelect2.default,
                (0, _extends3.default)({}, props, {
                    optionLabelProp: "value",
                    dropdownClassName: "rich-select",
                    onSelect: this.handleSelect }),
                this.getDropDownHeadElement(),
                this.getDropDownBodyElement()
            );
        }
    }]);
    return TextAreaRichSelect;
}(_react.Component);

TextAreaRichSelect.PropTypes = {
    dataBody: _propTypes2.default.array,
    dataHeader: _propTypes2.default.array,
    dropdwonMaxRows: _propTypes2.default.number
};

TextAreaRichSelect.defaultProps = {
    selectKey: "value",
    disabled: false,
    scrollHeight: 32,
    dropdownMatchSelectWidth: false,
    notFoundContent: 'not found'
};

exports.default = TextAreaRichSelect;
module.exports = exports['default'];