'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getMargin(margin) {
    var marginOptin = {
        min: '4',
        normal: '8',
        large: '16',
        left: "ml",
        right: "mr",
        top: 'mt',
        bottom: 'mb'
    };

    //当时string的时候，采用左右一致的间距
    if (typeof margin === "string") {
        var val = marginOptin[margin];
        var marginVal = 'ml' + val + ' mr' + val;
        return marginVal;

        //当是object 的时候采用
    } else {
        var _marginVal = "";
        for (var key in margin) {
            _marginVal += marginOptin[key] + marginOptin[margin[key]] + " ";
        }
        return _marginVal;
    }
}

function text(_ref) {
    var _classnames;

    var color = _ref.color,
        weight = _ref.weight,
        style = _ref.style,
        width = _ref.width,
        height = _ref.height,
        align = _ref.align,
        margin = _ref.margin,
        children = _ref.children,
        className = _ref.className;

    // 暂时不开放style 属性,style只支持 width 和 height
    var _width$height$color = { width: width, height: height, color: color },
        styles = (0, _objectWithoutProperties3.default)(_width$height$color, []);

    var alignOptin = {
        left: 'tal',
        right: 'tar dpb',
        center: 'tac dpb'
    };

    var _class = (0, _classnames3.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, "color-" + color, color), (0, _defineProperty3.default)(_classnames, "fwb", weight === 'bold'), (0, _defineProperty3.default)(_classnames, "fwn", weight === 'normal'), (0, _defineProperty3.default)(_classnames, alignOptin[align], align), (0, _defineProperty3.default)(_classnames, getMargin(margin) + ' dpib', margin), _classnames));
    _class += className || "";
    return _react2.default.createElement(
        'span',
        { className: _class, style: (0, _extends3.default)({}, styles) },
        children
    );
}

exports.default = text;
module.exports = exports['default'];