'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*eslint-disable */
var Base64 = {};
Base64.map = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
var stepLength = 3;
Base64.encode = function (s) {
  if (!s) {
    return;
  }

  s += '';
  if (s.length === 0) {
    return s;
  }
  s = escape(s);

  var i = void 0;
  var b = void 0;
  var x = [];
  var map = Base64.map;
  var padchar = map[64];
  var len = s.length - s.length % stepLength;

  for (i = 0; i < len; i += stepLength) {
    b = s.charCodeAt(i) << 16 | s.charCodeAt(i + 1) << 8 | s.charCodeAt(i + 2);
    x.push(map.charAt(b >> 18));
    x.push(map.charAt(b >> 12 & 0x3f));
    x.push(map.charAt(b >> 6 & 0x3f));
    x.push(map.charAt(b & 0x3f));
  }

  switch (s.length - len) {
    case 1:
      b = s.charCodeAt(i) << 16;
      x.push(map.charAt(b >> 18) + map.charAt(b >> 12 & 0x3f) + padchar + padchar);
      break;
    case 2:
      b = s.charCodeAt(i) << 16 | s.charCodeAt(i + 1) << 8;
      x.push(map.charAt(b >> 18) + map.charAt(b >> 12 & 0x3f) + map.charAt(b >> 6 & 0x3f) + padchar);
      break;
  }
  return x.join('');
};

/**
 * 替换+/=使之可用于URL传输  Add by 陈楠
 */
Base64.encodeUrlsafe = function (input) {
  var result = Base64.encode(input);
  result = result.replace(/[+\/]/g, function (m0) {
    return m0 === '+' ? '-' : '_';
  }).replace(/=/g, '*');
  return result;
};

/**
 * Add by 陈楠
 */
Base64.decodeUrlsafe = function (input) {
  input = input.replace(/[-_]/g, function (m0) {
    return m0 == '-' ? '+' : '/';
  }).replace(/\*/g, '=');
  var result = Base64.decode(input);
  return result;
};

Base64.decode = function (s) {
  s += '';
  var len = s.length;
  if (len === 0 || len % 4 !== 0) {
    return s;
  }

  var pads = 0;
  if (s.charAt(len - 1) === Base64.map[64]) {
    pads++;
    if (s.charAt(len - 2) === Base64.map[64]) {
      pads++;
    }
    len -= 4;
  }

  var i = void 0,
      b = void 0,
      map = Base64.map,
      x = [];
  for (i = 0; i < len; i += 4) {
    b = map.indexOf(s.charAt(i)) << 18 | map.indexOf(s.charAt(i + 1)) << 12 | map.indexOf(s.charAt(i + 2)) << 6 | map.indexOf(s.charAt(i + 3));
    x.push(String.fromCharCode(b >> 16, b >> 8 & 0xff, b & 0xff));
  }

  switch (pads) {
    case 1:
      b = map.indexOf(s.charAt(i)) << 18 | map.indexOf(s.charAt(i)) << 12 | map.indexOf(s.charAt(i)) << 6;
      x.push(String.fromCharCode(b >> 16, b >> 8 & 0xff));
      break;
    case 2:
      b = map.indexOf(s.charAt(i)) << 18 | map.indexOf(s.charAt(i)) << 12;
      x.push(String.fromCharCode(b >> 16));
      break;
  }
  return unescape(x.join(''));
};

exports.default = Base64;
module.exports = exports['default'];