'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var eventStore = {};

var addListener = function addListener(eventKey, func) {
  if (typeof func !== 'function') {
    return;
  }
  if (!Array.isArray(eventStore[eventKey])) {
    eventStore[eventKey] = [];
  }
  eventStore[eventKey].push(func);
};

var on = function on(eventKey, func) {
  if (typeof func !== 'function') {
    return;
  }
  eventStore[eventKey].push([func]);
};

var removeListener = function removeListener(eventKey, func) {
  if (Array.isArray(eventStore[eventKey])) {
    eventStore[eventKey] = eventStore[eventKey].filter(function (baseFunc) {
      return baseFunc !== func;
    });
  }
};

var removeAllListeners = function removeAllListeners(eventKey) {
  if (event === undefined) eventStore = {};else delete eventStore[eventKey];
};

var listeners = function listeners(eventKey) {
  return _lodash2.default.result(eventStore, eventKey + '', []);
};

var emit = function emit(eventKey, payload) {
  var funcArray = _lodash2.default.result(eventStore, eventKey + '', []);
  if (funcArray.length > 0) {
    funcArray.forEach(function (func) {
      func(payload);
    });
    return true;
  }
  return false;
};

exports.default = {
  addListener: addListener, on: on, removeListener: removeListener, removeAllListeners: removeAllListeners, listeners: listeners, emit: emit
};
module.exports = exports['default'];