"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
/**
 * 将常见的不可见字符转换为普通的空格字符
 * @param str
 * @returns {*}
 */
var replaceInvisibleCharacter = function replaceInvisibleCharacter(str) {
    var returnValue = "";
    if (!!str) {
        var space = " ";
        //排除掉 \r\n  \u000d\u000a
        var regEx = new RegExp("[\0-\t" + //：C0控制符及基本拉丁文 (C0 Control and Basic Latin)
        "\x0B-\f" + //：C0控制符及基本拉丁文 (C0 Control and Basic Latin)
        "\x0E-\x1F" + //：C0控制符及基本拉丁文 (C0 Control and Basic Latin)
        "\x7F-\xA0" + //：特殊 (Specials);
        "]", "g");
        returnValue = str.replace(regEx, space);
    }
    return returnValue;
};
// 全角转半角
var transformFullToHalf = function transformFullToHalf(str) {
    var returnValue = "";
    if (!!str) {
        for (var i = 0; i < str.length; i++) {
            if (str.charCodeAt(i) == 12288) {
                returnValue += String.fromCharCode(str.charCodeAt(i) - 12256);
                continue;
            }
            if (str.charCodeAt(i) > 65280 && str.charCodeAt(i) < 65375) {
                returnValue += String.fromCharCode(str.charCodeAt(i) - 65248);
            } else {
                returnValue += String.fromCharCode(str.charCodeAt(i));
            }
        }
    }
    return returnValue;
};

var processData = function processData(value, _this) {
    var _this$props = _this.props,
        needReplace = _this$props.needReplace,
        needUppercase = _this$props.needUppercase,
        needTransform = _this$props.needTransform;

    if (!!value && typeof value == 'string') {
        if (needTransform) {
            value = transformFullToHalf(value);
        }
        if (needReplace) {
            value = replaceInvisibleCharacter(value);
        }
        if (needUppercase) {
            value = value.toUpperCase();
        }
    }
    return value;
};

var handleOnBlur = function handleOnBlur(e, _this) {
    var value = _this.state.value;
    var _this$props2 = _this.props,
        onChange = _this$props2.onChange,
        onBlur = _this$props2.onBlur;

    var resultValue = processData(value, _this);
    if (resultValue !== value) {
        _this.setState({ value: resultValue });
        e.target.value = resultValue;
        onChange && onChange(e);
    }
    onBlur && onBlur(e);
};

var setPropsValue = function setPropsValue(_value, _this) {
    _this.setState({ value: _value });
};

exports.replaceInvisibleCharacter = replaceInvisibleCharacter;
exports.transformFullToHalf = transformFullToHalf;
exports.handleOnBlur = handleOnBlur;
exports.setPropsValue = setPropsValue;