"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.default = request;

require("fetch-detector");

require("fetch-ie8");

var _Base = require("./Base64");

var _Base2 = _interopRequireDefault(_Base);

var _message = require("../../antd/message");

var _message2 = _interopRequireDefault(_message);

require("../../antd/message/style");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var btnLeftTime = 0;

function checkBtnCanClick() {
    return btnLeftTime == 0 ? true : false;
}

function setBtnLeftTime(time) {
    btnLeftTime = time;
    setTimeout(function () {
        btnLeftTime = 0;
    }, time * 1000 + 500);
}

function showMessage(msg, type, time) {
    if (checkBtnCanClick()) {
        if (type === 'success') {
            _message2.default.success(msg, time ? time : 2);
            setBtnLeftTime(time ? time : 2);
        } else if (type === 'error') {
            _message2.default.error(msg, time ? time : 2);
            setBtnLeftTime(time ? time : 2);
        } else if (type === 'warning') {
            _message2.default.warning(msg, time ? time : 2);
            setBtnLeftTime(time ? time : 2);
        }
    }
};

var rquery = /\?/;

function parseJSON(response) {
    return response.json();
}

function checkStatus(response) {
    if (response.status >= 200 && response.status < 300) {
        return response;
    }

    checkDcas(response);

    var error = new Error(response.statusText);
    error.response = response;
    throw error;
}

function checkErrCode(json) {
    if (Number(json.resultCode) == 420) {
        goToLogin(json);
    } else if (Number(json.resultCode) == 506) {
        showMessage(json.resultMsg, 'error');
        var error = new Error(json.resultMsg);
        throw error;
    } else {
        return json;
    }
}

function goToLogin(json) {
    var dcasStateValiURL = json.dcasStateValiURL,
        backurl = json.backurl;

    backurl = location.protocol + "//" + location.host + "/membership/redirect";
    // 添加backurl
    backurl += (rquery.test(backurl) ? '&' : '?') + "target=" + encodeURI(_Base2.default.encodeUrlsafe(encodeURI(location.href)));
    dcasStateValiURL += (rquery.test(dcasStateValiURL) ? '&' : '?') + "backurl=" + _Base2.default.encodeUrlsafe(backurl);
    // 直接跳转到dcas验证
    top.location.href = dcasStateValiURL;
}
/**
 * 检查并处理 dcas 420错误
 * @param response
 */
function checkDcas(response) {

    if (response.status === 420) {
        response.text().then(function (info) {
            var jsonData = new Function("return " + info)();
            goToLogin(jsonData);
        });
    }
}

function showLoading() {
    var loading = document.getElementById('loading');
    if (null == loading) {
        var div = document.createElement("div");
        div.id = "loading";
        document.body.appendChild(div);
    }
}

function removeLoading(url) {
    loadingQueue.splice(loadingQueue.indexOf(url), 1);
    var loading = document.getElementById('loading');
    if (null != loading && loadingQueue.length === 0) {
        document.body.removeChild(loading);
    }
}

var loadingQueue = [];

/**
 * Requests a URL, returning a promise.
 *
 * @param  {string} url       The URL we want to request
 * @param  {object} [options] The options we want to pass to "fetch"
 * @return {object}           An object containing either "data" or "err"
 */
function request(url) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { method: 'POST' };
    var headers = options.headers,
        needLoad = options.needLoad,
        other = (0, _objectWithoutProperties3.default)(options, ["headers", "needLoad"]);

    var opts = (0, _extends3.default)({
        mode: 'cors', // 支持跨域
        credentials: 'include', // 带cookie,
        headers: (0, _extends3.default)({
            'X-Requested-With': 'XMLHttpRequest', // ajax标识
            'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8' }, headers)
    }, other);

    if (needLoad) {
        loadingQueue.push(url);
        showLoading();
    }

    return fetch(url, opts).then(checkStatus).then(parseJSON).then(checkErrCode).then(function (data) {
        needLoad ? setTimeout(function () {
            return removeLoading(url);
        }, 50) : null;return data;
    }).catch(function (err) {
        needLoad ? setTimeout(function () {
            return removeLoading(url);
        }, 50) : null;return err;
    });
}
module.exports = exports["default"];